// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventPipe.py

******************************************************************/


#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/common.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipeprovider.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipeevent.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipe.h"

#if defined(TARGET_UNIX)
#define wcslen PAL_wcslen
#endif

bool ResizeBuffer(char *&buffer, size_t& size, size_t currLen, size_t newSize, bool &fixedBuffer);
bool WriteToBuffer(PCWSTR str, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const char *str, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const BYTE *src, size_t len, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);

template <typename T>
bool WriteToBuffer(const T &value, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer)
{
    if (sizeof(T) + offset > size)
    {
        if (!ResizeBuffer(buffer, size, offset, size + sizeof(T), fixedBuffer))
            return false;
    }

    memcpy(buffer + offset, (char *)&value, sizeof(T));
    offset += sizeof(T);
    return true;
}

const WCHAR* DotNETRuntimeRundownName = W("Microsoft-Windows-DotNETRuntimeRundown");
EventPipeProvider *EventPipeProviderDotNETRuntimeRundown = nullptr;
EventPipeEvent *EventPipeEventCLRStackWalkDCStart = nullptr;
EventPipeEvent *EventPipeEventMethodDCStart = nullptr;
EventPipeEvent *EventPipeEventMethodDCStart_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodDCStart_V2 = nullptr;
EventPipeEvent *EventPipeEventMethodDCEnd = nullptr;
EventPipeEvent *EventPipeEventMethodDCEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodDCEnd_V2 = nullptr;
EventPipeEvent *EventPipeEventMethodDCStartVerbose = nullptr;
EventPipeEvent *EventPipeEventMethodDCStartVerbose_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodDCStartVerbose_V2 = nullptr;
EventPipeEvent *EventPipeEventMethodDCEndVerbose = nullptr;
EventPipeEvent *EventPipeEventMethodDCEndVerbose_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodDCEndVerbose_V2 = nullptr;
EventPipeEvent *EventPipeEventDCStartComplete = nullptr;
EventPipeEvent *EventPipeEventDCStartComplete_V1 = nullptr;
EventPipeEvent *EventPipeEventDCEndComplete = nullptr;
EventPipeEvent *EventPipeEventDCEndComplete_V1 = nullptr;
EventPipeEvent *EventPipeEventDCStartInit = nullptr;
EventPipeEvent *EventPipeEventDCStartInit_V1 = nullptr;
EventPipeEvent *EventPipeEventDCEndInit = nullptr;
EventPipeEvent *EventPipeEventDCEndInit_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodDCStartILToNativeMap = nullptr;
EventPipeEvent *EventPipeEventMethodDCEndILToNativeMap = nullptr;
EventPipeEvent *EventPipeEventDomainModuleDCStart = nullptr;
EventPipeEvent *EventPipeEventDomainModuleDCStart_V1 = nullptr;
EventPipeEvent *EventPipeEventDomainModuleDCEnd = nullptr;
EventPipeEvent *EventPipeEventDomainModuleDCEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventModuleDCStart = nullptr;
EventPipeEvent *EventPipeEventModuleDCStart_V1 = nullptr;
EventPipeEvent *EventPipeEventModuleDCStart_V2 = nullptr;
EventPipeEvent *EventPipeEventModuleDCEnd = nullptr;
EventPipeEvent *EventPipeEventModuleDCEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventModuleDCEnd_V2 = nullptr;
EventPipeEvent *EventPipeEventAssemblyDCStart = nullptr;
EventPipeEvent *EventPipeEventAssemblyDCStart_V1 = nullptr;
EventPipeEvent *EventPipeEventAssemblyDCEnd = nullptr;
EventPipeEvent *EventPipeEventAssemblyDCEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventAppDomainDCStart = nullptr;
EventPipeEvent *EventPipeEventAppDomainDCStart_V1 = nullptr;
EventPipeEvent *EventPipeEventAppDomainDCEnd = nullptr;
EventPipeEvent *EventPipeEventAppDomainDCEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventThreadDC = nullptr;
EventPipeEvent *EventPipeEventModuleRangeDCStart = nullptr;
EventPipeEvent *EventPipeEventModuleRangeDCEnd = nullptr;
EventPipeEvent *EventPipeEventRuntimeInformationDCStart = nullptr;
EventPipeEvent *EventPipeEventTieredCompilationSettingsDCStart = nullptr;
BOOL EventPipeEventEnabledCLRStackWalkDCStart()
{
    return EventPipeEventCLRStackWalkDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCLRStackWalkDCStart(
    const unsigned short ClrInstanceID,
    const unsigned char Reserved1,
    const unsigned char Reserved2,
    const unsigned int FrameCount,
    const void** Stack,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCLRStackWalkDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FrameCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Stack, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCLRStackWalkDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStart()
{
    return EventPipeEventMethodDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStart(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[36];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 36;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStart_V1()
{
    return EventPipeEventMethodDCStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStart_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[38];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 38;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStart_V2()
{
    return EventPipeEventMethodDCStart_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStart_V2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStart_V2())
        return ERROR_SUCCESS;

    char stackBuffer[46];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 46;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStart_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEnd()
{
    return EventPipeEventMethodDCEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEnd(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEnd())
        return ERROR_SUCCESS;

    char stackBuffer[36];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 36;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEnd_V1()
{
    return EventPipeEventMethodDCEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEnd_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[38];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 38;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEnd_V2()
{
    return EventPipeEventMethodDCEnd_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEnd_V2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEnd_V2())
        return ERROR_SUCCESS;

    char stackBuffer[46];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 46;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEnd_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStartVerbose()
{
    return EventPipeEventMethodDCStartVerbose->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStartVerbose(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStartVerbose())
        return ERROR_SUCCESS;

    char stackBuffer[228];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 228;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStartVerbose, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStartVerbose_V1()
{
    return EventPipeEventMethodDCStartVerbose_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStartVerbose_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStartVerbose_V1())
        return ERROR_SUCCESS;

    char stackBuffer[230];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 230;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStartVerbose_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStartVerbose_V2()
{
    return EventPipeEventMethodDCStartVerbose_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStartVerbose_V2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStartVerbose_V2())
        return ERROR_SUCCESS;

    char stackBuffer[238];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 238;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStartVerbose_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEndVerbose()
{
    return EventPipeEventMethodDCEndVerbose->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEndVerbose(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEndVerbose())
        return ERROR_SUCCESS;

    char stackBuffer[228];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 228;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEndVerbose, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEndVerbose_V1()
{
    return EventPipeEventMethodDCEndVerbose_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEndVerbose_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEndVerbose_V1())
        return ERROR_SUCCESS;

    char stackBuffer[230];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 230;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEndVerbose_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEndVerbose_V2()
{
    return EventPipeEventMethodDCEndVerbose_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEndVerbose_V2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEndVerbose_V2())
        return ERROR_SUCCESS;

    char stackBuffer[238];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 238;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEndVerbose_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCStartComplete()
{
    return EventPipeEventDCStartComplete->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCStartComplete(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCStartComplete())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDCStartComplete, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCStartComplete_V1()
{
    return EventPipeEventDCStartComplete_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCStartComplete_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCStartComplete_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDCStartComplete_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCEndComplete()
{
    return EventPipeEventDCEndComplete->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCEndComplete(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCEndComplete())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDCEndComplete, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCEndComplete_V1()
{
    return EventPipeEventDCEndComplete_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCEndComplete_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCEndComplete_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDCEndComplete_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCStartInit()
{
    return EventPipeEventDCStartInit->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCStartInit(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCStartInit())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDCStartInit, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCStartInit_V1()
{
    return EventPipeEventDCStartInit_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCStartInit_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCStartInit_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDCStartInit_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCEndInit()
{
    return EventPipeEventDCEndInit->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCEndInit(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCEndInit())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDCEndInit, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCEndInit_V1()
{
    return EventPipeEventDCEndInit_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCEndInit_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCEndInit_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDCEndInit_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStartILToNativeMap()
{
    return EventPipeEventMethodDCStartILToNativeMap->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStartILToNativeMap(
    const unsigned __int64 MethodID,
    const unsigned __int64 ReJITID,
    const unsigned char MethodExtent,
    const unsigned short CountOfMapEntries,
    const unsigned int* ILOffsets,
    const unsigned int* NativeOffsets,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStartILToNativeMap())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodExtent, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)ILOffsets, sizeof(const unsigned int) * (int)CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)NativeOffsets, sizeof(const unsigned int) * (int)CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStartILToNativeMap, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEndILToNativeMap()
{
    return EventPipeEventMethodDCEndILToNativeMap->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEndILToNativeMap(
    const unsigned __int64 MethodID,
    const unsigned __int64 ReJITID,
    const unsigned char MethodExtent,
    const unsigned short CountOfMapEntries,
    const unsigned int* ILOffsets,
    const unsigned int* NativeOffsets,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEndILToNativeMap())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodExtent, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)ILOffsets, sizeof(const unsigned int) * (int)CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)NativeOffsets, sizeof(const unsigned int) * (int)CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEndILToNativeMap, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDomainModuleDCStart()
{
    return EventPipeEventDomainModuleDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDomainModuleDCStart(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDomainModuleDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[160];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 160;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDomainModuleDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDomainModuleDCStart_V1()
{
    return EventPipeEventDomainModuleDCStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDomainModuleDCStart_V1(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDomainModuleDCStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[162];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 162;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDomainModuleDCStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDomainModuleDCEnd()
{
    return EventPipeEventDomainModuleDCEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDomainModuleDCEnd(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDomainModuleDCEnd())
        return ERROR_SUCCESS;

    char stackBuffer[160];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 160;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDomainModuleDCEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDomainModuleDCEnd_V1()
{
    return EventPipeEventDomainModuleDCEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDomainModuleDCEnd_V1(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDomainModuleDCEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[162];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 162;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDomainModuleDCEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleDCStart()
{
    return EventPipeEventModuleDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleDCStart(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[152];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 152;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleDCStart_V1()
{
    return EventPipeEventModuleDCStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleDCStart_V1(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[154];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 154;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleDCStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleDCStart_V2()
{
    return EventPipeEventModuleDCStart_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleDCStart_V2(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int ManagedPdbAge,
    PCWSTR ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int NativePdbAge,
    PCWSTR NativePdbBuildPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCStart_V2())
        return ERROR_SUCCESS;

    char stackBuffer[290];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 290;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*ManagedPdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbBuildPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*NativePdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbBuildPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleDCStart_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleDCEnd()
{
    return EventPipeEventModuleDCEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleDCEnd(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCEnd())
        return ERROR_SUCCESS;

    char stackBuffer[152];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 152;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleDCEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleDCEnd_V1()
{
    return EventPipeEventModuleDCEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleDCEnd_V1(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[154];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 154;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleDCEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleDCEnd_V2()
{
    return EventPipeEventModuleDCEnd_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleDCEnd_V2(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int ManagedPdbAge,
    PCWSTR ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int NativePdbAge,
    PCWSTR NativePdbBuildPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCEnd_V2())
        return ERROR_SUCCESS;

    char stackBuffer[290];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 290;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*ManagedPdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbBuildPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*NativePdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbBuildPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleDCEnd_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyDCStart()
{
    return EventPipeEventAssemblyDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyDCStart(
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[84];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 84;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyDCStart_V1()
{
    return EventPipeEventAssemblyDCStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyDCStart_V1(
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned __int64 BindingID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyDCStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[94];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 94;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BindingID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyDCStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyDCEnd()
{
    return EventPipeEventAssemblyDCEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyDCEnd(
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyDCEnd())
        return ERROR_SUCCESS;

    char stackBuffer[84];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 84;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyDCEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyDCEnd_V1()
{
    return EventPipeEventAssemblyDCEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyDCEnd_V1(
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned __int64 BindingID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyDCEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[94];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 94;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BindingID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyDCEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainDCStart()
{
    return EventPipeEventAppDomainDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainDCStart(
    const unsigned __int64 AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[76];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 76;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainDCStart_V1()
{
    return EventPipeEventAppDomainDCStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainDCStart_V1(
    const unsigned __int64 AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    const unsigned int AppDomainIndex,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainDCStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainDCStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainDCEnd()
{
    return EventPipeEventAppDomainDCEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainDCEnd(
    const unsigned __int64 AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainDCEnd())
        return ERROR_SUCCESS;

    char stackBuffer[76];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 76;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainDCEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainDCEnd_V1()
{
    return EventPipeEventAppDomainDCEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainDCEnd_V1(
    const unsigned __int64 AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    const unsigned int AppDomainIndex,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainDCEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainDCEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadDC()
{
    return EventPipeEventThreadDC->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadDC(
    const unsigned __int64 ManagedThreadID,
    const unsigned __int64 AppDomainID,
    const unsigned int Flags,
    const unsigned int ManagedThreadIndex,
    const unsigned int OSThreadID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadDC())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ManagedThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Flags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedThreadIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(OSThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadDC, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleRangeDCStart()
{
    return EventPipeEventModuleRangeDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleRangeDCStart(
    const unsigned short ClrInstanceID,
    const unsigned __int64 ModuleID,
    const unsigned int RangeBegin,
    const unsigned int RangeSize,
    const unsigned char RangeType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleRangeDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeBegin, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeType, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleRangeDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleRangeDCEnd()
{
    return EventPipeEventModuleRangeDCEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleRangeDCEnd(
    const unsigned short ClrInstanceID,
    const unsigned __int64 ModuleID,
    const unsigned int RangeBegin,
    const unsigned int RangeSize,
    const unsigned char RangeType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleRangeDCEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeBegin, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeType, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleRangeDCEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledRuntimeInformationDCStart()
{
    return EventPipeEventRuntimeInformationDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventRuntimeInformationDCStart(
    const unsigned short ClrInstanceID,
    const unsigned short Sku,
    const unsigned short BclMajorVersion,
    const unsigned short BclMinorVersion,
    const unsigned short BclBuildNumber,
    const unsigned short BclQfeNumber,
    const unsigned short VMMajorVersion,
    const unsigned short VMMinorVersion,
    const unsigned short VMBuildNumber,
    const unsigned short VMQfeNumber,
    const unsigned int StartupFlags,
    const unsigned char StartupMode,
    PCWSTR CommandLine,
    const GUID* ComObjectGuid,
    PCWSTR RuntimeDllPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledRuntimeInformationDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[153];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 153;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Sku, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BclMajorVersion, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BclMinorVersion, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BclBuildNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BclQfeNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VMMajorVersion, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VMMinorVersion, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VMBuildNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VMQfeNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StartupFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StartupMode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CommandLine, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*ComObjectGuid, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RuntimeDllPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventRuntimeInformationDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTieredCompilationSettingsDCStart()
{
    return EventPipeEventTieredCompilationSettingsDCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTieredCompilationSettingsDCStart(
    const unsigned short ClrInstanceID,
    const unsigned int Flags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTieredCompilationSettingsDCStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Flags, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTieredCompilationSettingsDCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

extern "C" void InitDotNETRuntimeRundown()
{
    EventPipeProviderDotNETRuntimeRundown = EventPipe::CreateProvider(SL(DotNETRuntimeRundownName), EventPipeEtwCallbackDotNETRuntimeRundown);
    EventPipeEventCLRStackWalkDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(0,1073741824,0,EventPipeEventLevel::LogAlways,true);
    EventPipeEventMethodDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(141,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCStart_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(141,48,1,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCStart_V2 = EventPipeProviderDotNETRuntimeRundown->AddEvent(141,48,2,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCEnd = EventPipeProviderDotNETRuntimeRundown->AddEvent(142,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCEnd_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(142,48,1,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCEnd_V2 = EventPipeProviderDotNETRuntimeRundown->AddEvent(142,48,2,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCStartVerbose = EventPipeProviderDotNETRuntimeRundown->AddEvent(143,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCStartVerbose_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(143,48,1,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCStartVerbose_V2 = EventPipeProviderDotNETRuntimeRundown->AddEvent(143,48,2,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCEndVerbose = EventPipeProviderDotNETRuntimeRundown->AddEvent(144,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCEndVerbose_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(144,48,1,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCEndVerbose_V2 = EventPipeProviderDotNETRuntimeRundown->AddEvent(144,48,2,EventPipeEventLevel::Informational,true);
    EventPipeEventDCStartComplete = EventPipeProviderDotNETRuntimeRundown->AddEvent(145,131128,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDCStartComplete_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(145,131128,1,EventPipeEventLevel::Informational,true);
    EventPipeEventDCEndComplete = EventPipeProviderDotNETRuntimeRundown->AddEvent(146,131128,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDCEndComplete_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(146,131128,1,EventPipeEventLevel::Informational,true);
    EventPipeEventDCStartInit = EventPipeProviderDotNETRuntimeRundown->AddEvent(147,131128,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDCStartInit_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(147,131128,1,EventPipeEventLevel::Informational,true);
    EventPipeEventDCEndInit = EventPipeProviderDotNETRuntimeRundown->AddEvent(148,131128,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDCEndInit_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(148,131128,1,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCStartILToNativeMap = EventPipeProviderDotNETRuntimeRundown->AddEvent(149,131072,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventMethodDCEndILToNativeMap = EventPipeProviderDotNETRuntimeRundown->AddEvent(150,131072,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventDomainModuleDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(151,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDomainModuleDCStart_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(151,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventDomainModuleDCEnd = EventPipeProviderDotNETRuntimeRundown->AddEvent(152,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDomainModuleDCEnd_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(152,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(153,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleDCStart_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(153,536870920,1,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleDCStart_V2 = EventPipeProviderDotNETRuntimeRundown->AddEvent(153,536870920,2,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleDCEnd = EventPipeProviderDotNETRuntimeRundown->AddEvent(154,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleDCEnd_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(154,536870920,1,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleDCEnd_V2 = EventPipeProviderDotNETRuntimeRundown->AddEvent(154,536870920,2,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(155,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyDCStart_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(155,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyDCEnd = EventPipeProviderDotNETRuntimeRundown->AddEvent(156,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyDCEnd_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(156,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(157,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainDCStart_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(157,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainDCEnd = EventPipeProviderDotNETRuntimeRundown->AddEvent(158,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainDCEnd_V1 = EventPipeProviderDotNETRuntimeRundown->AddEvent(158,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventThreadDC = EventPipeProviderDotNETRuntimeRundown->AddEvent(159,67584,0,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleRangeDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(160,536870912,0,EventPipeEventLevel::Informational,false);
    EventPipeEventModuleRangeDCEnd = EventPipeProviderDotNETRuntimeRundown->AddEvent(161,536870912,0,EventPipeEventLevel::Informational,false);
    EventPipeEventRuntimeInformationDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(187,0,0,EventPipeEventLevel::Informational,true);
    EventPipeEventTieredCompilationSettingsDCStart = EventPipeProviderDotNETRuntimeRundown->AddEvent(280,68719476736,0,EventPipeEventLevel::Informational,false);
}
