// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventPipe.py

******************************************************************/


#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/common.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipeprovider.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipeevent.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipe.h"

#if defined(TARGET_UNIX)
#define wcslen PAL_wcslen
#endif

bool ResizeBuffer(char *&buffer, size_t& size, size_t currLen, size_t newSize, bool &fixedBuffer);
bool WriteToBuffer(PCWSTR str, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const char *str, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const BYTE *src, size_t len, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);

template <typename T>
bool WriteToBuffer(const T &value, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer)
{
    if (sizeof(T) + offset > size)
    {
        if (!ResizeBuffer(buffer, size, offset, size + sizeof(T), fixedBuffer))
            return false;
    }

    memcpy(buffer + offset, (char *)&value, sizeof(T));
    offset += sizeof(T);
    return true;
}

const WCHAR* DotNETRuntimeStressName = W("Microsoft-Windows-DotNETRuntimeStress");
EventPipeProvider *EventPipeProviderDotNETRuntimeStress = nullptr;
EventPipeEvent *EventPipeEventStressLogEvent = nullptr;
EventPipeEvent *EventPipeEventStressLogEvent_V1 = nullptr;
EventPipeEvent *EventPipeEventCLRStackWalkStress = nullptr;
BOOL EventPipeEventEnabledStressLogEvent()
{
    return EventPipeEventStressLogEvent->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventStressLogEvent(
    const unsigned int Facility,
    const unsigned char LogLevel,
    LPCSTR Message,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledStressLogEvent())
        return ERROR_SUCCESS;

    char stackBuffer[37];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 37;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Facility, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LogLevel, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Message, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventStressLogEvent, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledStressLogEvent_V1()
{
    return EventPipeEventStressLogEvent_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventStressLogEvent_V1(
    const unsigned int Facility,
    const unsigned char LogLevel,
    LPCSTR Message,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledStressLogEvent_V1())
        return ERROR_SUCCESS;

    char stackBuffer[39];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 39;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Facility, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LogLevel, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Message, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventStressLogEvent_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCLRStackWalkStress()
{
    return EventPipeEventCLRStackWalkStress->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCLRStackWalkStress(
    const unsigned short ClrInstanceID,
    const unsigned char Reserved1,
    const unsigned char Reserved2,
    const unsigned int FrameCount,
    const void** Stack,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCLRStackWalkStress())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FrameCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Stack, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCLRStackWalkStress, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

extern "C" void InitDotNETRuntimeStress()
{
    EventPipeProviderDotNETRuntimeStress = EventPipe::CreateProvider(SL(DotNETRuntimeStressName), EventPipeEtwCallbackDotNETRuntimeStress);
    EventPipeEventStressLogEvent = EventPipeProviderDotNETRuntimeStress->AddEvent(0,0,0,EventPipeEventLevel::Informational,true);
    EventPipeEventStressLogEvent_V1 = EventPipeProviderDotNETRuntimeStress->AddEvent(0,0,1,EventPipeEventLevel::Informational,true);
    EventPipeEventCLRStackWalkStress = EventPipeProviderDotNETRuntimeStress->AddEvent(1,1073741824,0,EventPipeEventLevel::LogAlways,true);
}
