// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventPipe.py

******************************************************************/


#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/common.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipeprovider.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipeevent.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipe.h"

#if defined(TARGET_UNIX)
#define wcslen PAL_wcslen
#endif

bool ResizeBuffer(char *&buffer, size_t& size, size_t currLen, size_t newSize, bool &fixedBuffer);
bool WriteToBuffer(PCWSTR str, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const char *str, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const BYTE *src, size_t len, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);

template <typename T>
bool WriteToBuffer(const T &value, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer)
{
    if (sizeof(T) + offset > size)
    {
        if (!ResizeBuffer(buffer, size, offset, size + sizeof(T), fixedBuffer))
            return false;
    }

    memcpy(buffer + offset, (char *)&value, sizeof(T));
    offset += sizeof(T);
    return true;
}

const WCHAR* DotNETRuntimeName = W("Microsoft-Windows-DotNETRuntime");
EventPipeProvider *EventPipeProviderDotNETRuntime = nullptr;
EventPipeEvent *EventPipeEventGCStart = nullptr;
EventPipeEvent *EventPipeEventGCStart_V1 = nullptr;
EventPipeEvent *EventPipeEventGCStart_V2 = nullptr;
EventPipeEvent *EventPipeEventGCEnd = nullptr;
EventPipeEvent *EventPipeEventGCEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGCRestartEEEnd = nullptr;
EventPipeEvent *EventPipeEventGCRestartEEEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGCHeapStats = nullptr;
EventPipeEvent *EventPipeEventGCHeapStats_V1 = nullptr;
EventPipeEvent *EventPipeEventGCHeapStats_V2 = nullptr;
EventPipeEvent *EventPipeEventGCCreateSegment = nullptr;
EventPipeEvent *EventPipeEventGCCreateSegment_V1 = nullptr;
EventPipeEvent *EventPipeEventGCFreeSegment = nullptr;
EventPipeEvent *EventPipeEventGCFreeSegment_V1 = nullptr;
EventPipeEvent *EventPipeEventGCRestartEEBegin = nullptr;
EventPipeEvent *EventPipeEventGCRestartEEBegin_V1 = nullptr;
EventPipeEvent *EventPipeEventGCSuspendEEEnd = nullptr;
EventPipeEvent *EventPipeEventGCSuspendEEEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGCSuspendEEBegin = nullptr;
EventPipeEvent *EventPipeEventGCSuspendEEBegin_V1 = nullptr;
EventPipeEvent *EventPipeEventGCAllocationTick = nullptr;
EventPipeEvent *EventPipeEventGCAllocationTick_V1 = nullptr;
EventPipeEvent *EventPipeEventGCAllocationTick_V2 = nullptr;
EventPipeEvent *EventPipeEventGCAllocationTick_V3 = nullptr;
EventPipeEvent *EventPipeEventGCCreateConcurrentThread = nullptr;
EventPipeEvent *EventPipeEventGCCreateConcurrentThread_V1 = nullptr;
EventPipeEvent *EventPipeEventGCTerminateConcurrentThread = nullptr;
EventPipeEvent *EventPipeEventGCTerminateConcurrentThread_V1 = nullptr;
EventPipeEvent *EventPipeEventGCFinalizersEnd = nullptr;
EventPipeEvent *EventPipeEventGCFinalizersEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGCFinalizersBegin = nullptr;
EventPipeEvent *EventPipeEventGCFinalizersBegin_V1 = nullptr;
EventPipeEvent *EventPipeEventBulkType = nullptr;
EventPipeEvent *EventPipeEventGCBulkRootEdge = nullptr;
EventPipeEvent *EventPipeEventGCBulkRootConditionalWeakTableElementEdge = nullptr;
EventPipeEvent *EventPipeEventGCBulkNode = nullptr;
EventPipeEvent *EventPipeEventGCBulkEdge = nullptr;
EventPipeEvent *EventPipeEventGCSampledObjectAllocationHigh = nullptr;
EventPipeEvent *EventPipeEventGCBulkSurvivingObjectRanges = nullptr;
EventPipeEvent *EventPipeEventGCBulkMovedObjectRanges = nullptr;
EventPipeEvent *EventPipeEventGCGenerationRange = nullptr;
EventPipeEvent *EventPipeEventGCMarkStackRoots = nullptr;
EventPipeEvent *EventPipeEventGCMarkFinalizeQueueRoots = nullptr;
EventPipeEvent *EventPipeEventGCMarkHandles = nullptr;
EventPipeEvent *EventPipeEventGCMarkOlderGenerationRoots = nullptr;
EventPipeEvent *EventPipeEventFinalizeObject = nullptr;
EventPipeEvent *EventPipeEventSetGCHandle = nullptr;
EventPipeEvent *EventPipeEventDestroyGCHandle = nullptr;
EventPipeEvent *EventPipeEventGCSampledObjectAllocationLow = nullptr;
EventPipeEvent *EventPipeEventPinObjectAtGCTime = nullptr;
EventPipeEvent *EventPipeEventGCTriggered = nullptr;
EventPipeEvent *EventPipeEventGCBulkRootCCW = nullptr;
EventPipeEvent *EventPipeEventGCBulkRCW = nullptr;
EventPipeEvent *EventPipeEventGCBulkRootStaticVar = nullptr;
EventPipeEvent *EventPipeEventGCDynamicEvent = nullptr;
EventPipeEvent *EventPipeEventWorkerThreadCreate = nullptr;
EventPipeEvent *EventPipeEventWorkerThreadTerminate = nullptr;
EventPipeEvent *EventPipeEventWorkerThreadRetire = nullptr;
EventPipeEvent *EventPipeEventWorkerThreadUnretire = nullptr;
EventPipeEvent *EventPipeEventIOThreadCreate = nullptr;
EventPipeEvent *EventPipeEventIOThreadCreate_V1 = nullptr;
EventPipeEvent *EventPipeEventIOThreadTerminate = nullptr;
EventPipeEvent *EventPipeEventIOThreadTerminate_V1 = nullptr;
EventPipeEvent *EventPipeEventIOThreadRetire = nullptr;
EventPipeEvent *EventPipeEventIOThreadRetire_V1 = nullptr;
EventPipeEvent *EventPipeEventIOThreadUnretire = nullptr;
EventPipeEvent *EventPipeEventIOThreadUnretire_V1 = nullptr;
EventPipeEvent *EventPipeEventThreadpoolSuspensionSuspendThread = nullptr;
EventPipeEvent *EventPipeEventThreadpoolSuspensionResumeThread = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadStart = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadStop = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadRetirementStart = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadRetirementStop = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadAdjustmentSample = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadAdjustmentAdjustment = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadAdjustmentStats = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkerThreadWait = nullptr;
EventPipeEvent *EventPipeEventThreadPoolWorkingThreadCount = nullptr;
EventPipeEvent *EventPipeEventThreadPoolEnqueue = nullptr;
EventPipeEvent *EventPipeEventThreadPoolDequeue = nullptr;
EventPipeEvent *EventPipeEventThreadPoolIOEnqueue = nullptr;
EventPipeEvent *EventPipeEventThreadPoolIODequeue = nullptr;
EventPipeEvent *EventPipeEventThreadPoolIOPack = nullptr;
EventPipeEvent *EventPipeEventThreadCreating = nullptr;
EventPipeEvent *EventPipeEventThreadRunning = nullptr;
EventPipeEvent *EventPipeEventMethodDetails = nullptr;
EventPipeEvent *EventPipeEventTypeLoadStart = nullptr;
EventPipeEvent *EventPipeEventTypeLoadStop = nullptr;
EventPipeEvent *EventPipeEventExceptionThrown = nullptr;
EventPipeEvent *EventPipeEventExceptionThrown_V1 = nullptr;
EventPipeEvent *EventPipeEventExceptionCatchStart = nullptr;
EventPipeEvent *EventPipeEventExceptionCatchStop = nullptr;
EventPipeEvent *EventPipeEventExceptionFinallyStart = nullptr;
EventPipeEvent *EventPipeEventExceptionFinallyStop = nullptr;
EventPipeEvent *EventPipeEventExceptionFilterStart = nullptr;
EventPipeEvent *EventPipeEventExceptionFilterStop = nullptr;
EventPipeEvent *EventPipeEventExceptionThrownStop = nullptr;
EventPipeEvent *EventPipeEventContention = nullptr;
EventPipeEvent *EventPipeEventContentionStart_V1 = nullptr;
EventPipeEvent *EventPipeEventContentionStop = nullptr;
EventPipeEvent *EventPipeEventContentionStop_V1 = nullptr;
EventPipeEvent *EventPipeEventCLRStackWalk = nullptr;
EventPipeEvent *EventPipeEventAppDomainMemAllocated = nullptr;
EventPipeEvent *EventPipeEventAppDomainMemSurvived = nullptr;
EventPipeEvent *EventPipeEventThreadCreated = nullptr;
EventPipeEvent *EventPipeEventThreadTerminated = nullptr;
EventPipeEvent *EventPipeEventThreadDomainEnter = nullptr;
EventPipeEvent *EventPipeEventILStubGenerated = nullptr;
EventPipeEvent *EventPipeEventILStubCacheHit = nullptr;
EventPipeEvent *EventPipeEventDCStartCompleteV2 = nullptr;
EventPipeEvent *EventPipeEventDCEndCompleteV2 = nullptr;
EventPipeEvent *EventPipeEventMethodDCStartV2 = nullptr;
EventPipeEvent *EventPipeEventMethodDCEndV2 = nullptr;
EventPipeEvent *EventPipeEventMethodDCStartVerboseV2 = nullptr;
EventPipeEvent *EventPipeEventMethodDCEndVerboseV2 = nullptr;
EventPipeEvent *EventPipeEventMethodLoad = nullptr;
EventPipeEvent *EventPipeEventMethodLoad_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodLoad_V2 = nullptr;
EventPipeEvent *EventPipeEventR2RGetEntryPoint = nullptr;
EventPipeEvent *EventPipeEventR2RGetEntryPointStart = nullptr;
EventPipeEvent *EventPipeEventMethodUnload = nullptr;
EventPipeEvent *EventPipeEventMethodUnload_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodUnload_V2 = nullptr;
EventPipeEvent *EventPipeEventMethodLoadVerbose = nullptr;
EventPipeEvent *EventPipeEventMethodLoadVerbose_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodLoadVerbose_V2 = nullptr;
EventPipeEvent *EventPipeEventMethodUnloadVerbose = nullptr;
EventPipeEvent *EventPipeEventMethodUnloadVerbose_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodUnloadVerbose_V2 = nullptr;
EventPipeEvent *EventPipeEventMethodJittingStarted = nullptr;
EventPipeEvent *EventPipeEventMethodJittingStarted_V1 = nullptr;
EventPipeEvent *EventPipeEventMethodJitInliningSucceeded = nullptr;
EventPipeEvent *EventPipeEventMethodJitInliningFailedAnsi = nullptr;
EventPipeEvent *EventPipeEventMethodJitTailCallSucceeded = nullptr;
EventPipeEvent *EventPipeEventMethodJitTailCallFailedAnsi = nullptr;
EventPipeEvent *EventPipeEventMethodILToNativeMap = nullptr;
EventPipeEvent *EventPipeEventMethodJitTailCallFailed = nullptr;
EventPipeEvent *EventPipeEventMethodJitInliningFailed = nullptr;
EventPipeEvent *EventPipeEventModuleDCStartV2 = nullptr;
EventPipeEvent *EventPipeEventModuleDCEndV2 = nullptr;
EventPipeEvent *EventPipeEventDomainModuleLoad = nullptr;
EventPipeEvent *EventPipeEventDomainModuleLoad_V1 = nullptr;
EventPipeEvent *EventPipeEventModuleLoad = nullptr;
EventPipeEvent *EventPipeEventModuleLoad_V1 = nullptr;
EventPipeEvent *EventPipeEventModuleLoad_V2 = nullptr;
EventPipeEvent *EventPipeEventModuleUnload = nullptr;
EventPipeEvent *EventPipeEventModuleUnload_V1 = nullptr;
EventPipeEvent *EventPipeEventModuleUnload_V2 = nullptr;
EventPipeEvent *EventPipeEventAssemblyLoad = nullptr;
EventPipeEvent *EventPipeEventAssemblyLoad_V1 = nullptr;
EventPipeEvent *EventPipeEventAssemblyUnload = nullptr;
EventPipeEvent *EventPipeEventAssemblyUnload_V1 = nullptr;
EventPipeEvent *EventPipeEventAppDomainLoad = nullptr;
EventPipeEvent *EventPipeEventAppDomainLoad_V1 = nullptr;
EventPipeEvent *EventPipeEventAppDomainUnload = nullptr;
EventPipeEvent *EventPipeEventAppDomainUnload_V1 = nullptr;
EventPipeEvent *EventPipeEventModuleRangeLoad = nullptr;
EventPipeEvent *EventPipeEventStrongNameVerificationStart = nullptr;
EventPipeEvent *EventPipeEventStrongNameVerificationStart_V1 = nullptr;
EventPipeEvent *EventPipeEventStrongNameVerificationStop = nullptr;
EventPipeEvent *EventPipeEventStrongNameVerificationStop_V1 = nullptr;
EventPipeEvent *EventPipeEventAuthenticodeVerificationStart = nullptr;
EventPipeEvent *EventPipeEventAuthenticodeVerificationStart_V1 = nullptr;
EventPipeEvent *EventPipeEventAuthenticodeVerificationStop = nullptr;
EventPipeEvent *EventPipeEventAuthenticodeVerificationStop_V1 = nullptr;
EventPipeEvent *EventPipeEventRuntimeInformationStart = nullptr;
EventPipeEvent *EventPipeEventIncreaseMemoryPressure = nullptr;
EventPipeEvent *EventPipeEventDecreaseMemoryPressure = nullptr;
EventPipeEvent *EventPipeEventGCMarkWithType = nullptr;
EventPipeEvent *EventPipeEventGCJoin_V2 = nullptr;
EventPipeEvent *EventPipeEventGCPerHeapHistory_V3 = nullptr;
EventPipeEvent *EventPipeEventGCGlobalHeapHistory_V2 = nullptr;
EventPipeEvent *EventPipeEventGCGlobalHeapHistory_V3 = nullptr;
EventPipeEvent *EventPipeEventGenAwareBegin = nullptr;
EventPipeEvent *EventPipeEventGenAwareEnd = nullptr;
EventPipeEvent *EventPipeEventDebugIPCEventStart = nullptr;
EventPipeEvent *EventPipeEventDebugIPCEventEnd = nullptr;
EventPipeEvent *EventPipeEventDebugExceptionProcessingStart = nullptr;
EventPipeEvent *EventPipeEventDebugExceptionProcessingEnd = nullptr;
EventPipeEvent *EventPipeEventCodeSymbols = nullptr;
EventPipeEvent *EventPipeEventEventSource = nullptr;
EventPipeEvent *EventPipeEventTieredCompilationSettings = nullptr;
EventPipeEvent *EventPipeEventTieredCompilationPause = nullptr;
EventPipeEvent *EventPipeEventTieredCompilationResume = nullptr;
EventPipeEvent *EventPipeEventTieredCompilationBackgroundJitStart = nullptr;
EventPipeEvent *EventPipeEventTieredCompilationBackgroundJitStop = nullptr;
EventPipeEvent *EventPipeEventAssemblyLoadStart = nullptr;
EventPipeEvent *EventPipeEventAssemblyLoadStop = nullptr;
EventPipeEvent *EventPipeEventResolutionAttempted = nullptr;
EventPipeEvent *EventPipeEventAssemblyLoadContextResolvingHandlerInvoked = nullptr;
EventPipeEvent *EventPipeEventAppDomainAssemblyResolveHandlerInvoked = nullptr;
EventPipeEvent *EventPipeEventAssemblyLoadFromResolveHandlerInvoked = nullptr;
EventPipeEvent *EventPipeEventKnownPathProbed = nullptr;
BOOL EventPipeEventEnabledGCStart()
{
    return EventPipeEventGCStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCStart(
    const unsigned int Count,
    const unsigned int Reason,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCStart_V1()
{
    return EventPipeEventGCStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCStart_V1(
    const unsigned int Count,
    const unsigned int Depth,
    const unsigned int Reason,
    const unsigned int Type,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Depth, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCStart_V2()
{
    return EventPipeEventGCStart_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCStart_V2(
    const unsigned int Count,
    const unsigned int Depth,
    const unsigned int Reason,
    const unsigned int Type,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ClientSequenceNumber,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCStart_V2())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Depth, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClientSequenceNumber, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCStart_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCEnd()
{
    return EventPipeEventGCEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCEnd(
    const unsigned int Count,
    const unsigned short Depth,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Depth, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCEnd_V1()
{
    return EventPipeEventGCEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCEnd_V1(
    const unsigned int Count,
    const unsigned int Depth,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Depth, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCRestartEEEnd()
{
    return EventPipeEventGCRestartEEEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCRestartEEEnd(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCRestartEEEnd())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventGCRestartEEEnd, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCRestartEEEnd_V1()
{
    return EventPipeEventGCRestartEEEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCRestartEEEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCRestartEEEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCRestartEEEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCHeapStats()
{
    return EventPipeEventGCHeapStats->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCHeapStats(
    const unsigned __int64 GenerationSize0,
    const unsigned __int64 TotalPromotedSize0,
    const unsigned __int64 GenerationSize1,
    const unsigned __int64 TotalPromotedSize1,
    const unsigned __int64 GenerationSize2,
    const unsigned __int64 TotalPromotedSize2,
    const unsigned __int64 GenerationSize3,
    const unsigned __int64 TotalPromotedSize3,
    const unsigned __int64 FinalizationPromotedSize,
    const unsigned __int64 FinalizationPromotedCount,
    const unsigned int PinnedObjectCount,
    const unsigned int SinkBlockCount,
    const unsigned int GCHandleCount,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCHeapStats())
        return ERROR_SUCCESS;

    char stackBuffer[92];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 92;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(GenerationSize0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize3, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize3, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FinalizationPromotedSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FinalizationPromotedCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PinnedObjectCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SinkBlockCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GCHandleCount, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCHeapStats, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCHeapStats_V1()
{
    return EventPipeEventGCHeapStats_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCHeapStats_V1(
    const unsigned __int64 GenerationSize0,
    const unsigned __int64 TotalPromotedSize0,
    const unsigned __int64 GenerationSize1,
    const unsigned __int64 TotalPromotedSize1,
    const unsigned __int64 GenerationSize2,
    const unsigned __int64 TotalPromotedSize2,
    const unsigned __int64 GenerationSize3,
    const unsigned __int64 TotalPromotedSize3,
    const unsigned __int64 FinalizationPromotedSize,
    const unsigned __int64 FinalizationPromotedCount,
    const unsigned int PinnedObjectCount,
    const unsigned int SinkBlockCount,
    const unsigned int GCHandleCount,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCHeapStats_V1())
        return ERROR_SUCCESS;

    char stackBuffer[94];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 94;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(GenerationSize0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize3, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize3, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FinalizationPromotedSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FinalizationPromotedCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PinnedObjectCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SinkBlockCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GCHandleCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCHeapStats_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCHeapStats_V2()
{
    return EventPipeEventGCHeapStats_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCHeapStats_V2(
    const unsigned __int64 GenerationSize0,
    const unsigned __int64 TotalPromotedSize0,
    const unsigned __int64 GenerationSize1,
    const unsigned __int64 TotalPromotedSize1,
    const unsigned __int64 GenerationSize2,
    const unsigned __int64 TotalPromotedSize2,
    const unsigned __int64 GenerationSize3,
    const unsigned __int64 TotalPromotedSize3,
    const unsigned __int64 FinalizationPromotedSize,
    const unsigned __int64 FinalizationPromotedCount,
    const unsigned int PinnedObjectCount,
    const unsigned int SinkBlockCount,
    const unsigned int GCHandleCount,
    const unsigned short ClrInstanceID,
    const unsigned __int64 GenerationSize4,
    const unsigned __int64 TotalPromotedSize4,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCHeapStats_V2())
        return ERROR_SUCCESS;

    char stackBuffer[110];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 110;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(GenerationSize0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize3, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize3, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FinalizationPromotedSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FinalizationPromotedCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PinnedObjectCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SinkBlockCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GCHandleCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationSize4, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalPromotedSize4, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCHeapStats_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCCreateSegment()
{
    return EventPipeEventGCCreateSegment->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCCreateSegment(
    const unsigned __int64 Address,
    const unsigned __int64 Size,
    const unsigned int Type,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCCreateSegment())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Size, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCCreateSegment, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCCreateSegment_V1()
{
    return EventPipeEventGCCreateSegment_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCCreateSegment_V1(
    const unsigned __int64 Address,
    const unsigned __int64 Size,
    const unsigned int Type,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCCreateSegment_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Size, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCCreateSegment_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFreeSegment()
{
    return EventPipeEventGCFreeSegment->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCFreeSegment(
    const unsigned __int64 Address,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFreeSegment())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCFreeSegment, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFreeSegment_V1()
{
    return EventPipeEventGCFreeSegment_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCFreeSegment_V1(
    const unsigned __int64 Address,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFreeSegment_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCFreeSegment_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCRestartEEBegin()
{
    return EventPipeEventGCRestartEEBegin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCRestartEEBegin(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCRestartEEBegin())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventGCRestartEEBegin, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCRestartEEBegin_V1()
{
    return EventPipeEventGCRestartEEBegin_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCRestartEEBegin_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCRestartEEBegin_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCRestartEEBegin_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSuspendEEEnd()
{
    return EventPipeEventGCSuspendEEEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCSuspendEEEnd(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSuspendEEEnd())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventGCSuspendEEEnd, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSuspendEEEnd_V1()
{
    return EventPipeEventGCSuspendEEEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCSuspendEEEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSuspendEEEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCSuspendEEEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSuspendEEBegin()
{
    return EventPipeEventGCSuspendEEBegin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCSuspendEEBegin(
    const unsigned short Reason,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSuspendEEBegin())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCSuspendEEBegin, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSuspendEEBegin_V1()
{
    return EventPipeEventGCSuspendEEBegin_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCSuspendEEBegin_V1(
    const unsigned int Reason,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSuspendEEBegin_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCSuspendEEBegin_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCAllocationTick()
{
    return EventPipeEventGCAllocationTick->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCAllocationTick(
    const unsigned int AllocationAmount,
    const unsigned int AllocationKind,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCAllocationTick())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AllocationAmount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AllocationKind, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCAllocationTick, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCAllocationTick_V1()
{
    return EventPipeEventGCAllocationTick_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCAllocationTick_V1(
    const unsigned int AllocationAmount,
    const unsigned int AllocationKind,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCAllocationTick_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AllocationAmount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AllocationKind, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCAllocationTick_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCAllocationTick_V2()
{
    return EventPipeEventGCAllocationTick_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCAllocationTick_V2(
    const unsigned int AllocationAmount,
    const unsigned int AllocationKind,
    const unsigned short ClrInstanceID,
    const unsigned __int64 AllocationAmount64,
    const void* TypeID,
    PCWSTR TypeName,
    const unsigned int HeapIndex,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCAllocationTick_V2())
        return ERROR_SUCCESS;

    char stackBuffer[94];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 94;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AllocationAmount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AllocationKind, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AllocationAmount64, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(HeapIndex, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCAllocationTick_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCAllocationTick_V3()
{
    return EventPipeEventGCAllocationTick_V3->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCAllocationTick_V3(
    const unsigned int AllocationAmount,
    const unsigned int AllocationKind,
    const unsigned short ClrInstanceID,
    const unsigned __int64 AllocationAmount64,
    const void* TypeID,
    PCWSTR TypeName,
    const unsigned int HeapIndex,
    const void* Address,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCAllocationTick_V3())
        return ERROR_SUCCESS;

    char stackBuffer[102];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 102;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AllocationAmount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AllocationKind, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AllocationAmount64, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(HeapIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCAllocationTick_V3, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCCreateConcurrentThread()
{
    return EventPipeEventGCCreateConcurrentThread->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCCreateConcurrentThread(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCCreateConcurrentThread())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventGCCreateConcurrentThread, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCCreateConcurrentThread_V1()
{
    return EventPipeEventGCCreateConcurrentThread_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCCreateConcurrentThread_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCCreateConcurrentThread_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCCreateConcurrentThread_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCTerminateConcurrentThread()
{
    return EventPipeEventGCTerminateConcurrentThread->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCTerminateConcurrentThread(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCTerminateConcurrentThread())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventGCTerminateConcurrentThread, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCTerminateConcurrentThread_V1()
{
    return EventPipeEventGCTerminateConcurrentThread_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCTerminateConcurrentThread_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCTerminateConcurrentThread_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCTerminateConcurrentThread_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFinalizersEnd()
{
    return EventPipeEventGCFinalizersEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCFinalizersEnd(
    const unsigned int Count,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFinalizersEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCFinalizersEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFinalizersEnd_V1()
{
    return EventPipeEventGCFinalizersEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCFinalizersEnd_V1(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFinalizersEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCFinalizersEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFinalizersBegin()
{
    return EventPipeEventGCFinalizersBegin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCFinalizersBegin(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFinalizersBegin())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventGCFinalizersBegin, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFinalizersBegin_V1()
{
    return EventPipeEventGCFinalizersBegin_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCFinalizersBegin_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFinalizersBegin_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCFinalizersBegin_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBulkType()
{
    return EventPipeEventBulkType->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBulkType(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBulkType())
        return ERROR_SUCCESS;

    char stackBuffer[38];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 38;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)(Values_ElementSize), buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBulkType, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRootEdge()
{
    return EventPipeEventGCBulkRootEdge->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkRootEdge(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRootEdge())
        return ERROR_SUCCESS;

    char stackBuffer[42];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 42;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkRootEdge, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRootConditionalWeakTableElementEdge()
{
    return EventPipeEventGCBulkRootConditionalWeakTableElementEdge->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkRootConditionalWeakTableElementEdge(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRootConditionalWeakTableElementEdge())
        return ERROR_SUCCESS;

    char stackBuffer[42];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 42;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkRootConditionalWeakTableElementEdge, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkNode()
{
    return EventPipeEventGCBulkNode->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkNode(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkNode())
        return ERROR_SUCCESS;

    char stackBuffer[42];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 42;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkNode, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkEdge()
{
    return EventPipeEventGCBulkEdge->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkEdge(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkEdge())
        return ERROR_SUCCESS;

    char stackBuffer[42];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 42;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkEdge, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSampledObjectAllocationHigh()
{
    return EventPipeEventGCSampledObjectAllocationHigh->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCSampledObjectAllocationHigh(
    const void* Address,
    const void* TypeID,
    const unsigned int ObjectCountForTypeSample,
    const unsigned __int64 TotalSizeForTypeSample,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSampledObjectAllocationHigh())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectCountForTypeSample, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalSizeForTypeSample, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCSampledObjectAllocationHigh, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkSurvivingObjectRanges()
{
    return EventPipeEventGCBulkSurvivingObjectRanges->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkSurvivingObjectRanges(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkSurvivingObjectRanges())
        return ERROR_SUCCESS;

    char stackBuffer[42];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 42;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkSurvivingObjectRanges, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkMovedObjectRanges()
{
    return EventPipeEventGCBulkMovedObjectRanges->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkMovedObjectRanges(
    const unsigned int Index,
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkMovedObjectRanges())
        return ERROR_SUCCESS;

    char stackBuffer[42];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 42;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Index, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkMovedObjectRanges, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCGenerationRange()
{
    return EventPipeEventGCGenerationRange->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCGenerationRange(
    const unsigned char Generation,
    const void* RangeStart,
    const unsigned __int64 RangeUsedLength,
    const unsigned __int64 RangeReservedLength,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCGenerationRange())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Generation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeStart, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeUsedLength, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeReservedLength, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCGenerationRange, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkStackRoots()
{
    return EventPipeEventGCMarkStackRoots->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCMarkStackRoots(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkStackRoots())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCMarkStackRoots, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkFinalizeQueueRoots()
{
    return EventPipeEventGCMarkFinalizeQueueRoots->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCMarkFinalizeQueueRoots(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkFinalizeQueueRoots())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCMarkFinalizeQueueRoots, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkHandles()
{
    return EventPipeEventGCMarkHandles->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCMarkHandles(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkHandles())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCMarkHandles, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkOlderGenerationRoots()
{
    return EventPipeEventGCMarkOlderGenerationRoots->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCMarkOlderGenerationRoots(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkOlderGenerationRoots())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCMarkOlderGenerationRoots, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFinalizeObject()
{
    return EventPipeEventFinalizeObject->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFinalizeObject(
    const void* TypeID,
    const void* ObjectID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFinalizeObject())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFinalizeObject, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledSetGCHandle()
{
    return EventPipeEventSetGCHandle->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventSetGCHandle(
    const void* HandleID,
    const void* ObjectID,
    const unsigned int Kind,
    const unsigned int Generation,
    const unsigned __int64 AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledSetGCHandle())
        return ERROR_SUCCESS;

    char stackBuffer[34];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 34;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Kind, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Generation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventSetGCHandle, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDestroyGCHandle()
{
    return EventPipeEventDestroyGCHandle->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDestroyGCHandle(
    const void* HandleID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDestroyGCHandle())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDestroyGCHandle, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSampledObjectAllocationLow()
{
    return EventPipeEventGCSampledObjectAllocationLow->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCSampledObjectAllocationLow(
    const void* Address,
    const void* TypeID,
    const unsigned int ObjectCountForTypeSample,
    const unsigned __int64 TotalSizeForTypeSample,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSampledObjectAllocationLow())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Address, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectCountForTypeSample, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalSizeForTypeSample, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCSampledObjectAllocationLow, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPinObjectAtGCTime()
{
    return EventPipeEventPinObjectAtGCTime->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPinObjectAtGCTime(
    const void* HandleID,
    const void* ObjectID,
    const unsigned __int64 ObjectSize,
    PCWSTR TypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPinObjectAtGCTime())
        return ERROR_SUCCESS;

    char stackBuffer[90];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 90;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPinObjectAtGCTime, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCTriggered()
{
    return EventPipeEventGCTriggered->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCTriggered(
    const unsigned int Reason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCTriggered())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCTriggered, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRootCCW()
{
    return EventPipeEventGCBulkRootCCW->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkRootCCW(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRootCCW())
        return ERROR_SUCCESS;

    char stackBuffer[38];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 38;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)(Values_ElementSize), buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkRootCCW, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRCW()
{
    return EventPipeEventGCBulkRCW->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkRCW(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRCW())
        return ERROR_SUCCESS;

    char stackBuffer[38];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 38;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)(Values_ElementSize), buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkRCW, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCBulkRootStaticVar()
{
    return EventPipeEventGCBulkRootStaticVar->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCBulkRootStaticVar(
    const unsigned int Count,
    const unsigned __int64 AppDomainID,
    const unsigned short ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCBulkRootStaticVar())
        return ERROR_SUCCESS;

    char stackBuffer[46];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 46;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)(Values_ElementSize), buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCBulkRootStaticVar, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCDynamicEvent()
{
    return EventPipeEventGCDynamicEvent->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCDynamicEvent(
    PCWSTR Name,
    const unsigned int DataSize,
    const BYTE* Data,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCDynamicEvent())
        return ERROR_SUCCESS;

    char stackBuffer[71];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 71;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Name, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DataSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Data, sizeof(const BYTE) * (int)DataSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCDynamicEvent, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledWorkerThreadCreate()
{
    return EventPipeEventWorkerThreadCreate->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventWorkerThreadCreate(
    const unsigned int WorkerThreadCount,
    const unsigned int RetiredWorkerThreads,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledWorkerThreadCreate())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(WorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreads, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventWorkerThreadCreate, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledWorkerThreadTerminate()
{
    return EventPipeEventWorkerThreadTerminate->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventWorkerThreadTerminate(
    const unsigned int WorkerThreadCount,
    const unsigned int RetiredWorkerThreads,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledWorkerThreadTerminate())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(WorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreads, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventWorkerThreadTerminate, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledWorkerThreadRetire()
{
    return EventPipeEventWorkerThreadRetire->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventWorkerThreadRetire(
    const unsigned int WorkerThreadCount,
    const unsigned int RetiredWorkerThreads,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledWorkerThreadRetire())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(WorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreads, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventWorkerThreadRetire, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledWorkerThreadUnretire()
{
    return EventPipeEventWorkerThreadUnretire->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventWorkerThreadUnretire(
    const unsigned int WorkerThreadCount,
    const unsigned int RetiredWorkerThreads,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledWorkerThreadUnretire())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(WorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreads, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventWorkerThreadUnretire, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIOThreadCreate()
{
    return EventPipeEventIOThreadCreate->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIOThreadCreate(
    const unsigned int IOThreadCount,
    const unsigned int RetiredIOThreads,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIOThreadCreate())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(IOThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredIOThreads, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIOThreadCreate, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIOThreadCreate_V1()
{
    return EventPipeEventIOThreadCreate_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIOThreadCreate_V1(
    const unsigned int IOThreadCount,
    const unsigned int RetiredIOThreads,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIOThreadCreate_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(IOThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredIOThreads, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIOThreadCreate_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIOThreadTerminate()
{
    return EventPipeEventIOThreadTerminate->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIOThreadTerminate(
    const unsigned int IOThreadCount,
    const unsigned int RetiredIOThreads,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIOThreadTerminate())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(IOThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredIOThreads, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIOThreadTerminate, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIOThreadTerminate_V1()
{
    return EventPipeEventIOThreadTerminate_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIOThreadTerminate_V1(
    const unsigned int IOThreadCount,
    const unsigned int RetiredIOThreads,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIOThreadTerminate_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(IOThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredIOThreads, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIOThreadTerminate_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIOThreadRetire()
{
    return EventPipeEventIOThreadRetire->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIOThreadRetire(
    const unsigned int IOThreadCount,
    const unsigned int RetiredIOThreads,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIOThreadRetire())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(IOThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredIOThreads, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIOThreadRetire, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIOThreadRetire_V1()
{
    return EventPipeEventIOThreadRetire_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIOThreadRetire_V1(
    const unsigned int IOThreadCount,
    const unsigned int RetiredIOThreads,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIOThreadRetire_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(IOThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredIOThreads, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIOThreadRetire_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIOThreadUnretire()
{
    return EventPipeEventIOThreadUnretire->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIOThreadUnretire(
    const unsigned int IOThreadCount,
    const unsigned int RetiredIOThreads,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIOThreadUnretire())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(IOThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredIOThreads, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIOThreadUnretire, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIOThreadUnretire_V1()
{
    return EventPipeEventIOThreadUnretire_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIOThreadUnretire_V1(
    const unsigned int IOThreadCount,
    const unsigned int RetiredIOThreads,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIOThreadUnretire_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(IOThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredIOThreads, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIOThreadUnretire_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadpoolSuspensionSuspendThread()
{
    return EventPipeEventThreadpoolSuspensionSuspendThread->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadpoolSuspensionSuspendThread(
    const unsigned int ClrThreadID,
    const unsigned int CpuUtilization,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadpoolSuspensionSuspendThread())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CpuUtilization, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadpoolSuspensionSuspendThread, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadpoolSuspensionResumeThread()
{
    return EventPipeEventThreadpoolSuspensionResumeThread->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadpoolSuspensionResumeThread(
    const unsigned int ClrThreadID,
    const unsigned int CpuUtilization,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadpoolSuspensionResumeThread())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CpuUtilization, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadpoolSuspensionResumeThread, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadStart()
{
    return EventPipeEventThreadPoolWorkerThreadStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkerThreadStart(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkerThreadStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadStop()
{
    return EventPipeEventThreadPoolWorkerThreadStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkerThreadStop(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadStop())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkerThreadStop, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadRetirementStart()
{
    return EventPipeEventThreadPoolWorkerThreadRetirementStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkerThreadRetirementStart(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadRetirementStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkerThreadRetirementStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadRetirementStop()
{
    return EventPipeEventThreadPoolWorkerThreadRetirementStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkerThreadRetirementStop(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadRetirementStop())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkerThreadRetirementStop, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentSample()
{
    return EventPipeEventThreadPoolWorkerThreadAdjustmentSample->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkerThreadAdjustmentSample(
    const double Throughput,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentSample())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Throughput, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkerThreadAdjustmentSample, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentAdjustment()
{
    return EventPipeEventThreadPoolWorkerThreadAdjustmentAdjustment->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkerThreadAdjustmentAdjustment(
    const double AverageThroughput,
    const unsigned int NewWorkerThreadCount,
    const unsigned int Reason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentAdjustment())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AverageThroughput, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkerThreadAdjustmentAdjustment, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentStats()
{
    return EventPipeEventThreadPoolWorkerThreadAdjustmentStats->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkerThreadAdjustmentStats(
    const double Duration,
    const double Throughput,
    const double ThreadWave,
    const double ThroughputWave,
    const double ThroughputErrorEstimate,
    const double AverageThroughputErrorEstimate,
    const double ThroughputRatio,
    const double Confidence,
    const double NewControlSetting,
    const unsigned short NewThreadWaveMagnitude,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentStats())
        return ERROR_SUCCESS;

    char stackBuffer[76];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 76;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Duration, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Throughput, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ThreadWave, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ThroughputWave, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ThroughputErrorEstimate, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AverageThroughputErrorEstimate, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ThroughputRatio, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Confidence, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewControlSetting, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewThreadWaveMagnitude, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkerThreadAdjustmentStats, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkerThreadWait()
{
    return EventPipeEventThreadPoolWorkerThreadWait->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkerThreadWait(
    const unsigned int ActiveWorkerThreadCount,
    const unsigned int RetiredWorkerThreadCount,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkerThreadWait())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ActiveWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RetiredWorkerThreadCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkerThreadWait, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolWorkingThreadCount()
{
    return EventPipeEventThreadPoolWorkingThreadCount->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolWorkingThreadCount(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolWorkingThreadCount())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolWorkingThreadCount, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolEnqueue()
{
    return EventPipeEventThreadPoolEnqueue->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolEnqueue(
    const void* WorkID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolEnqueue())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(WorkID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolEnqueue, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolDequeue()
{
    return EventPipeEventThreadPoolDequeue->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolDequeue(
    const void* WorkID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolDequeue())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(WorkID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolDequeue, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolIOEnqueue()
{
    return EventPipeEventThreadPoolIOEnqueue->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolIOEnqueue(
    const void* NativeOverlapped,
    const void* Overlapped,
    const BOOL MultiDequeues,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolIOEnqueue())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(NativeOverlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Overlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MultiDequeues, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolIOEnqueue, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolIODequeue()
{
    return EventPipeEventThreadPoolIODequeue->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolIODequeue(
    const void* NativeOverlapped,
    const void* Overlapped,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolIODequeue())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(NativeOverlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Overlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolIODequeue, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadPoolIOPack()
{
    return EventPipeEventThreadPoolIOPack->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadPoolIOPack(
    const void* NativeOverlapped,
    const void* Overlapped,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadPoolIOPack())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(NativeOverlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Overlapped, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadPoolIOPack, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadCreating()
{
    return EventPipeEventThreadCreating->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadCreating(
    const void* ID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadCreating())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadCreating, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadRunning()
{
    return EventPipeEventThreadRunning->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadRunning(
    const void* ID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadRunning())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadRunning, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDetails()
{
    return EventPipeEventMethodDetails->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDetails(
    const unsigned __int64 MethodID,
    const unsigned __int64 TypeID,
    const unsigned int MethodToken,
    const unsigned int TypeParameterCount,
    const unsigned __int64 LoaderModuleID,
    const unsigned __int64* TypeParameters,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDetails())
        return ERROR_SUCCESS;

    char stackBuffer[40];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 40;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeParameterCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoaderModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)TypeParameters, sizeof(const unsigned __int64) * (int)TypeParameterCount, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDetails, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTypeLoadStart()
{
    return EventPipeEventTypeLoadStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTypeLoadStart(
    const unsigned int TypeLoadStartID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTypeLoadStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeLoadStartID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTypeLoadStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTypeLoadStop()
{
    return EventPipeEventTypeLoadStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTypeLoadStop(
    const unsigned int TypeLoadStartID,
    const unsigned short ClrInstanceID,
    const unsigned short LoadLevel,
    const unsigned __int64 TypeID,
    PCWSTR TypeName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTypeLoadStop())
        return ERROR_SUCCESS;

    char stackBuffer[80];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 80;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeLoadStartID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadLevel, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTypeLoadStop, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionThrown()
{
    return EventPipeEventExceptionThrown->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionThrown(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionThrown())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventExceptionThrown, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionThrown_V1()
{
    return EventPipeEventExceptionThrown_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionThrown_V1(
    PCWSTR ExceptionType,
    PCWSTR ExceptionMessage,
    const void* ExceptionEIP,
    const unsigned int ExceptionHRESULT,
    const unsigned short ExceptionFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionThrown_V1())
        return ERROR_SUCCESS;

    char stackBuffer[144];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 144;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ExceptionType, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExceptionMessage, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExceptionEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExceptionHRESULT, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExceptionFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExceptionThrown_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionCatchStart()
{
    return EventPipeEventExceptionCatchStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionCatchStart(
    const unsigned __int64 EntryEIP,
    const unsigned __int64 MethodID,
    PCWSTR MethodName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionCatchStart())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(EntryEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExceptionCatchStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionCatchStop()
{
    return EventPipeEventExceptionCatchStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionCatchStop(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionCatchStop())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventExceptionCatchStop, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionFinallyStart()
{
    return EventPipeEventExceptionFinallyStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionFinallyStart(
    const unsigned __int64 EntryEIP,
    const unsigned __int64 MethodID,
    PCWSTR MethodName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionFinallyStart())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(EntryEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExceptionFinallyStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionFinallyStop()
{
    return EventPipeEventExceptionFinallyStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionFinallyStop(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionFinallyStop())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventExceptionFinallyStop, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionFilterStart()
{
    return EventPipeEventExceptionFilterStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionFilterStart(
    const unsigned __int64 EntryEIP,
    const unsigned __int64 MethodID,
    PCWSTR MethodName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionFilterStart())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(EntryEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExceptionFilterStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionFilterStop()
{
    return EventPipeEventExceptionFilterStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionFilterStop(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionFilterStop())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventExceptionFilterStop, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExceptionThrownStop()
{
    return EventPipeEventExceptionThrownStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExceptionThrownStop(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExceptionThrownStop())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventExceptionThrownStop, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledContention()
{
    return EventPipeEventContention->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventContention(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledContention())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventContention, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledContentionStart_V1()
{
    return EventPipeEventContentionStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventContentionStart_V1(
    const unsigned char ContentionFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledContentionStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ContentionFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventContentionStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledContentionStop()
{
    return EventPipeEventContentionStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventContentionStop(
    const unsigned char ContentionFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledContentionStop())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ContentionFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventContentionStop, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledContentionStop_V1()
{
    return EventPipeEventContentionStop_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventContentionStop_V1(
    const unsigned char ContentionFlags,
    const unsigned short ClrInstanceID,
    const double DurationNs,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledContentionStop_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ContentionFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DurationNs, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventContentionStop_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCLRStackWalk()
{
    return EventPipeEventCLRStackWalk->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCLRStackWalk(
    const unsigned short ClrInstanceID,
    const unsigned char Reserved1,
    const unsigned char Reserved2,
    const unsigned int FrameCount,
    const void** Stack,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCLRStackWalk())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FrameCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Stack, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCLRStackWalk, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainMemAllocated()
{
    return EventPipeEventAppDomainMemAllocated->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainMemAllocated(
    const unsigned __int64 AppDomainID,
    const unsigned __int64 Allocated,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainMemAllocated())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Allocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainMemAllocated, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainMemSurvived()
{
    return EventPipeEventAppDomainMemSurvived->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainMemSurvived(
    const unsigned __int64 AppDomainID,
    const unsigned __int64 Survived,
    const unsigned __int64 ProcessSurvived,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainMemSurvived())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Survived, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ProcessSurvived, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainMemSurvived, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadCreated()
{
    return EventPipeEventThreadCreated->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadCreated(
    const unsigned __int64 ManagedThreadID,
    const unsigned __int64 AppDomainID,
    const unsigned int Flags,
    const unsigned int ManagedThreadIndex,
    const unsigned int OSThreadID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadCreated())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ManagedThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Flags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedThreadIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(OSThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadCreated, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadTerminated()
{
    return EventPipeEventThreadTerminated->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadTerminated(
    const unsigned __int64 ManagedThreadID,
    const unsigned __int64 AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadTerminated())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ManagedThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadTerminated, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledThreadDomainEnter()
{
    return EventPipeEventThreadDomainEnter->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventThreadDomainEnter(
    const unsigned __int64 ManagedThreadID,
    const unsigned __int64 AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledThreadDomainEnter())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ManagedThreadID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventThreadDomainEnter, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledILStubGenerated()
{
    return EventPipeEventILStubGenerated->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventILStubGenerated(
    const unsigned short ClrInstanceID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 StubMethodID,
    const unsigned int StubFlags,
    const unsigned int ManagedInteropMethodToken,
    PCWSTR ManagedInteropMethodNamespace,
    PCWSTR ManagedInteropMethodName,
    PCWSTR ManagedInteropMethodSignature,
    PCWSTR NativeMethodSignature,
    PCWSTR StubMethodSignature,
    PCWSTR StubMethodILCode,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledILStubGenerated())
        return ERROR_SUCCESS;

    char stackBuffer[410];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 410;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StubMethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StubFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedInteropMethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedInteropMethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedInteropMethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedInteropMethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativeMethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StubMethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StubMethodILCode, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventILStubGenerated, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledILStubCacheHit()
{
    return EventPipeEventILStubCacheHit->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventILStubCacheHit(
    const unsigned short ClrInstanceID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 StubMethodID,
    const unsigned int ManagedInteropMethodToken,
    PCWSTR ManagedInteropMethodNamespace,
    PCWSTR ManagedInteropMethodName,
    PCWSTR ManagedInteropMethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledILStubCacheHit())
        return ERROR_SUCCESS;

    char stackBuffer[214];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 214;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StubMethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedInteropMethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedInteropMethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedInteropMethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedInteropMethodSignature, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventILStubCacheHit, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCStartCompleteV2()
{
    return EventPipeEventDCStartCompleteV2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCStartCompleteV2(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCStartCompleteV2())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDCStartCompleteV2, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDCEndCompleteV2()
{
    return EventPipeEventDCEndCompleteV2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDCEndCompleteV2(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDCEndCompleteV2())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDCEndCompleteV2, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStartV2()
{
    return EventPipeEventMethodDCStartV2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStartV2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStartV2())
        return ERROR_SUCCESS;

    char stackBuffer[36];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 36;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStartV2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEndV2()
{
    return EventPipeEventMethodDCEndV2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEndV2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEndV2())
        return ERROR_SUCCESS;

    char stackBuffer[36];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 36;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEndV2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCStartVerboseV2()
{
    return EventPipeEventMethodDCStartVerboseV2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCStartVerboseV2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCStartVerboseV2())
        return ERROR_SUCCESS;

    char stackBuffer[228];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 228;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCStartVerboseV2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodDCEndVerboseV2()
{
    return EventPipeEventMethodDCEndVerboseV2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodDCEndVerboseV2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodDCEndVerboseV2())
        return ERROR_SUCCESS;

    char stackBuffer[228];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 228;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodDCEndVerboseV2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodLoad()
{
    return EventPipeEventMethodLoad->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodLoad(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodLoad())
        return ERROR_SUCCESS;

    char stackBuffer[36];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 36;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodLoad, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodLoad_V1()
{
    return EventPipeEventMethodLoad_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodLoad_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodLoad_V1())
        return ERROR_SUCCESS;

    char stackBuffer[38];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 38;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodLoad_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodLoad_V2()
{
    return EventPipeEventMethodLoad_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodLoad_V2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodLoad_V2())
        return ERROR_SUCCESS;

    char stackBuffer[46];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 46;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodLoad_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledR2RGetEntryPoint()
{
    return EventPipeEventR2RGetEntryPoint->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventR2RGetEntryPoint(
    const unsigned __int64 MethodID,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned __int64 EntryPoint,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledR2RGetEntryPoint())
        return ERROR_SUCCESS;

    char stackBuffer[210];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 210;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(EntryPoint, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventR2RGetEntryPoint, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledR2RGetEntryPointStart()
{
    return EventPipeEventR2RGetEntryPointStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventR2RGetEntryPointStart(
    const unsigned __int64 MethodID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledR2RGetEntryPointStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventR2RGetEntryPointStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodUnload()
{
    return EventPipeEventMethodUnload->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodUnload(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodUnload())
        return ERROR_SUCCESS;

    char stackBuffer[36];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 36;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodUnload, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodUnload_V1()
{
    return EventPipeEventMethodUnload_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodUnload_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodUnload_V1())
        return ERROR_SUCCESS;

    char stackBuffer[38];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 38;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodUnload_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodUnload_V2()
{
    return EventPipeEventMethodUnload_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodUnload_V2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodUnload_V2())
        return ERROR_SUCCESS;

    char stackBuffer[46];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 46;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodUnload_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodLoadVerbose()
{
    return EventPipeEventMethodLoadVerbose->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodLoadVerbose(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodLoadVerbose())
        return ERROR_SUCCESS;

    char stackBuffer[228];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 228;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodLoadVerbose, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodLoadVerbose_V1()
{
    return EventPipeEventMethodLoadVerbose_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodLoadVerbose_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodLoadVerbose_V1())
        return ERROR_SUCCESS;

    char stackBuffer[230];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 230;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodLoadVerbose_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodLoadVerbose_V2()
{
    return EventPipeEventMethodLoadVerbose_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodLoadVerbose_V2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodLoadVerbose_V2())
        return ERROR_SUCCESS;

    char stackBuffer[238];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 238;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodLoadVerbose_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodUnloadVerbose()
{
    return EventPipeEventMethodUnloadVerbose->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodUnloadVerbose(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodUnloadVerbose())
        return ERROR_SUCCESS;

    char stackBuffer[228];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 228;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodUnloadVerbose, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodUnloadVerbose_V1()
{
    return EventPipeEventMethodUnloadVerbose_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodUnloadVerbose_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodUnloadVerbose_V1())
        return ERROR_SUCCESS;

    char stackBuffer[230];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 230;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodUnloadVerbose_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodUnloadVerbose_V2()
{
    return EventPipeEventMethodUnloadVerbose_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodUnloadVerbose_V2(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    const unsigned __int64 ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodUnloadVerbose_V2())
        return ERROR_SUCCESS;

    char stackBuffer[238];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 238;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodStartAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodUnloadVerbose_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodJittingStarted()
{
    return EventPipeEventMethodJittingStarted->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodJittingStarted(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned int MethodToken,
    const unsigned int MethodILSize,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodJittingStarted())
        return ERROR_SUCCESS;

    char stackBuffer[216];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 216;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodILSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodJittingStarted, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodJittingStarted_V1()
{
    return EventPipeEventMethodJittingStarted_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodJittingStarted_V1(
    const unsigned __int64 MethodID,
    const unsigned __int64 ModuleID,
    const unsigned int MethodToken,
    const unsigned int MethodILSize,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodJittingStarted_V1())
        return ERROR_SUCCESS;

    char stackBuffer[218];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 218;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodToken, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodILSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodJittingStarted_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodJitInliningSucceeded()
{
    return EventPipeEventMethodJitInliningSucceeded->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodJitInliningSucceeded(
    PCWSTR MethodBeingCompiledNamespace,
    PCWSTR MethodBeingCompiledName,
    PCWSTR MethodBeingCompiledNameSignature,
    PCWSTR InlinerNamespace,
    PCWSTR InlinerName,
    PCWSTR InlinerNameSignature,
    PCWSTR InlineeNamespace,
    PCWSTR InlineeName,
    PCWSTR InlineeNameSignature,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodJitInliningSucceeded())
        return ERROR_SUCCESS;

    char stackBuffer[578];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 578;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodBeingCompiledNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodJitInliningSucceeded, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodJitInliningFailedAnsi()
{
    return EventPipeEventMethodJitInliningFailedAnsi->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodJitInliningFailedAnsi(
    PCWSTR MethodBeingCompiledNamespace,
    PCWSTR MethodBeingCompiledName,
    PCWSTR MethodBeingCompiledNameSignature,
    PCWSTR InlinerNamespace,
    PCWSTR InlinerName,
    PCWSTR InlinerNameSignature,
    PCWSTR InlineeNamespace,
    PCWSTR InlineeName,
    PCWSTR InlineeNameSignature,
    const BOOL FailAlways,
    LPCSTR FailReason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodJitInliningFailedAnsi())
        return ERROR_SUCCESS;

    char stackBuffer[614];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 614;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodBeingCompiledNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FailAlways, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FailReason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodJitInliningFailedAnsi, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodJitTailCallSucceeded()
{
    return EventPipeEventMethodJitTailCallSucceeded->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodJitTailCallSucceeded(
    PCWSTR MethodBeingCompiledNamespace,
    PCWSTR MethodBeingCompiledName,
    PCWSTR MethodBeingCompiledNameSignature,
    PCWSTR CallerNamespace,
    PCWSTR CallerName,
    PCWSTR CallerNameSignature,
    PCWSTR CalleeNamespace,
    PCWSTR CalleeName,
    PCWSTR CalleeNameSignature,
    const BOOL TailPrefix,
    const unsigned int TailCallType,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodJitTailCallSucceeded())
        return ERROR_SUCCESS;

    char stackBuffer[586];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 586;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodBeingCompiledNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TailPrefix, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TailCallType, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodJitTailCallSucceeded, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodJitTailCallFailedAnsi()
{
    return EventPipeEventMethodJitTailCallFailedAnsi->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodJitTailCallFailedAnsi(
    PCWSTR MethodBeingCompiledNamespace,
    PCWSTR MethodBeingCompiledName,
    PCWSTR MethodBeingCompiledNameSignature,
    PCWSTR CallerNamespace,
    PCWSTR CallerName,
    PCWSTR CallerNameSignature,
    PCWSTR CalleeNamespace,
    PCWSTR CalleeName,
    PCWSTR CalleeNameSignature,
    const BOOL TailPrefix,
    LPCSTR FailReason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodJitTailCallFailedAnsi())
        return ERROR_SUCCESS;

    char stackBuffer[614];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 614;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodBeingCompiledNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TailPrefix, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FailReason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodJitTailCallFailedAnsi, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodILToNativeMap()
{
    return EventPipeEventMethodILToNativeMap->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodILToNativeMap(
    const unsigned __int64 MethodID,
    const unsigned __int64 ReJITID,
    const unsigned char MethodExtent,
    const unsigned short CountOfMapEntries,
    const unsigned int* ILOffsets,
    const unsigned int* NativeOffsets,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodILToNativeMap())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReJITID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodExtent, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)ILOffsets, sizeof(const unsigned int) * (int)CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)NativeOffsets, sizeof(const unsigned int) * (int)CountOfMapEntries, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodILToNativeMap, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodJitTailCallFailed()
{
    return EventPipeEventMethodJitTailCallFailed->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodJitTailCallFailed(
    PCWSTR MethodBeingCompiledNamespace,
    PCWSTR MethodBeingCompiledName,
    PCWSTR MethodBeingCompiledNameSignature,
    PCWSTR CallerNamespace,
    PCWSTR CallerName,
    PCWSTR CallerNameSignature,
    PCWSTR CalleeNamespace,
    PCWSTR CalleeName,
    PCWSTR CalleeNameSignature,
    const BOOL TailPrefix,
    PCWSTR FailReason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodJitTailCallFailed())
        return ERROR_SUCCESS;

    char stackBuffer[646];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 646;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodBeingCompiledNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CallerNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CalleeNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TailPrefix, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FailReason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodJitTailCallFailed, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodJitInliningFailed()
{
    return EventPipeEventMethodJitInliningFailed->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodJitInliningFailed(
    PCWSTR MethodBeingCompiledNamespace,
    PCWSTR MethodBeingCompiledName,
    PCWSTR MethodBeingCompiledNameSignature,
    PCWSTR InlinerNamespace,
    PCWSTR InlinerName,
    PCWSTR InlinerNameSignature,
    PCWSTR InlineeNamespace,
    PCWSTR InlineeName,
    PCWSTR InlineeNameSignature,
    const BOOL FailAlways,
    PCWSTR FailReason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodJitInliningFailed())
        return ERROR_SUCCESS;

    char stackBuffer[646];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 646;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(MethodBeingCompiledNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodBeingCompiledNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlinerNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeNamespace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InlineeNameSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FailAlways, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FailReason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodJitInliningFailed, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleDCStartV2()
{
    return EventPipeEventModuleDCStartV2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleDCStartV2(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCStartV2())
        return ERROR_SUCCESS;

    char stackBuffer[152];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 152;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleDCStartV2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleDCEndV2()
{
    return EventPipeEventModuleDCEndV2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleDCEndV2(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleDCEndV2())
        return ERROR_SUCCESS;

    char stackBuffer[152];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 152;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleDCEndV2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDomainModuleLoad()
{
    return EventPipeEventDomainModuleLoad->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDomainModuleLoad(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDomainModuleLoad())
        return ERROR_SUCCESS;

    char stackBuffer[160];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 160;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDomainModuleLoad, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDomainModuleLoad_V1()
{
    return EventPipeEventDomainModuleLoad_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDomainModuleLoad_V1(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDomainModuleLoad_V1())
        return ERROR_SUCCESS;

    char stackBuffer[162];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 162;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDomainModuleLoad_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleLoad()
{
    return EventPipeEventModuleLoad->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleLoad(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleLoad())
        return ERROR_SUCCESS;

    char stackBuffer[152];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 152;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleLoad, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleLoad_V1()
{
    return EventPipeEventModuleLoad_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleLoad_V1(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleLoad_V1())
        return ERROR_SUCCESS;

    char stackBuffer[154];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 154;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleLoad_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleLoad_V2()
{
    return EventPipeEventModuleLoad_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleLoad_V2(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int ManagedPdbAge,
    PCWSTR ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int NativePdbAge,
    PCWSTR NativePdbBuildPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleLoad_V2())
        return ERROR_SUCCESS;

    char stackBuffer[290];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 290;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*ManagedPdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbBuildPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*NativePdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbBuildPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleLoad_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleUnload()
{
    return EventPipeEventModuleUnload->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleUnload(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleUnload())
        return ERROR_SUCCESS;

    char stackBuffer[152];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 152;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleUnload, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleUnload_V1()
{
    return EventPipeEventModuleUnload_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleUnload_V1(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleUnload_V1())
        return ERROR_SUCCESS;

    char stackBuffer[154];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 154;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleUnload_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleUnload_V2()
{
    return EventPipeEventModuleUnload_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleUnload_V2(
    const unsigned __int64 ModuleID,
    const unsigned __int64 AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int ManagedPdbAge,
    PCWSTR ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int NativePdbAge,
    PCWSTR NativePdbBuildPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleUnload_V2())
        return ERROR_SUCCESS;

    char stackBuffer[290];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 290;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleILPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleNativePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*ManagedPdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ManagedPdbBuildPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*NativePdbSignature, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbAge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NativePdbBuildPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleUnload_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyLoad()
{
    return EventPipeEventAssemblyLoad->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyLoad(
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyLoad())
        return ERROR_SUCCESS;

    char stackBuffer[84];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 84;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyLoad, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyLoad_V1()
{
    return EventPipeEventAssemblyLoad_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyLoad_V1(
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned __int64 BindingID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyLoad_V1())
        return ERROR_SUCCESS;

    char stackBuffer[94];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 94;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BindingID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyLoad_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyUnload()
{
    return EventPipeEventAssemblyUnload->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyUnload(
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyUnload())
        return ERROR_SUCCESS;

    char stackBuffer[84];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 84;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyUnload, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyUnload_V1()
{
    return EventPipeEventAssemblyUnload_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyUnload_V1(
    const unsigned __int64 AssemblyID,
    const unsigned __int64 AppDomainID,
    const unsigned __int64 BindingID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyUnload_V1())
        return ERROR_SUCCESS;

    char stackBuffer[94];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 94;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AssemblyID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BindingID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyUnload_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainLoad()
{
    return EventPipeEventAppDomainLoad->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainLoad(
    const unsigned __int64 AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainLoad())
        return ERROR_SUCCESS;

    char stackBuffer[76];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 76;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainLoad, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainLoad_V1()
{
    return EventPipeEventAppDomainLoad_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainLoad_V1(
    const unsigned __int64 AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    const unsigned int AppDomainIndex,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainLoad_V1())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainLoad_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainUnload()
{
    return EventPipeEventAppDomainUnload->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainUnload(
    const unsigned __int64 AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainUnload())
        return ERROR_SUCCESS;

    char stackBuffer[76];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 76;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainUnload, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainUnload_V1()
{
    return EventPipeEventAppDomainUnload_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainUnload_V1(
    const unsigned __int64 AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    const unsigned int AppDomainIndex,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainUnload_V1())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainUnload_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleRangeLoad()
{
    return EventPipeEventModuleRangeLoad->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleRangeLoad(
    const unsigned short ClrInstanceID,
    const unsigned __int64 ModuleID,
    const unsigned int RangeBegin,
    const unsigned int RangeSize,
    const unsigned char RangeType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleRangeLoad())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeBegin, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeType, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleRangeLoad, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledStrongNameVerificationStart()
{
    return EventPipeEventStrongNameVerificationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventStrongNameVerificationStart(
    const unsigned int VerificationFlags,
    const unsigned int ErrorCode,
    PCWSTR FullyQualifiedAssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledStrongNameVerificationStart())
        return ERROR_SUCCESS;

    char stackBuffer[72];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 72;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(VerificationFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventStrongNameVerificationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledStrongNameVerificationStart_V1()
{
    return EventPipeEventStrongNameVerificationStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventStrongNameVerificationStart_V1(
    const unsigned int VerificationFlags,
    const unsigned int ErrorCode,
    PCWSTR FullyQualifiedAssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledStrongNameVerificationStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[74];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 74;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(VerificationFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventStrongNameVerificationStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledStrongNameVerificationStop()
{
    return EventPipeEventStrongNameVerificationStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventStrongNameVerificationStop(
    const unsigned int VerificationFlags,
    const unsigned int ErrorCode,
    PCWSTR FullyQualifiedAssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledStrongNameVerificationStop())
        return ERROR_SUCCESS;

    char stackBuffer[72];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 72;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(VerificationFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventStrongNameVerificationStop, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledStrongNameVerificationStop_V1()
{
    return EventPipeEventStrongNameVerificationStop_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventStrongNameVerificationStop_V1(
    const unsigned int VerificationFlags,
    const unsigned int ErrorCode,
    PCWSTR FullyQualifiedAssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledStrongNameVerificationStop_V1())
        return ERROR_SUCCESS;

    char stackBuffer[74];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 74;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(VerificationFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FullyQualifiedAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventStrongNameVerificationStop_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAuthenticodeVerificationStart()
{
    return EventPipeEventAuthenticodeVerificationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAuthenticodeVerificationStart(
    const unsigned int VerificationFlags,
    const unsigned int ErrorCode,
    PCWSTR ModulePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAuthenticodeVerificationStart())
        return ERROR_SUCCESS;

    char stackBuffer[72];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 72;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(VerificationFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModulePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAuthenticodeVerificationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAuthenticodeVerificationStart_V1()
{
    return EventPipeEventAuthenticodeVerificationStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAuthenticodeVerificationStart_V1(
    const unsigned int VerificationFlags,
    const unsigned int ErrorCode,
    PCWSTR ModulePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAuthenticodeVerificationStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[74];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 74;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(VerificationFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModulePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAuthenticodeVerificationStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAuthenticodeVerificationStop()
{
    return EventPipeEventAuthenticodeVerificationStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAuthenticodeVerificationStop(
    const unsigned int VerificationFlags,
    const unsigned int ErrorCode,
    PCWSTR ModulePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAuthenticodeVerificationStop())
        return ERROR_SUCCESS;

    char stackBuffer[72];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 72;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(VerificationFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModulePath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAuthenticodeVerificationStop, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAuthenticodeVerificationStop_V1()
{
    return EventPipeEventAuthenticodeVerificationStop_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAuthenticodeVerificationStop_V1(
    const unsigned int VerificationFlags,
    const unsigned int ErrorCode,
    PCWSTR ModulePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAuthenticodeVerificationStop_V1())
        return ERROR_SUCCESS;

    char stackBuffer[74];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 74;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(VerificationFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModulePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAuthenticodeVerificationStop_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledRuntimeInformationStart()
{
    return EventPipeEventRuntimeInformationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventRuntimeInformationStart(
    const unsigned short ClrInstanceID,
    const unsigned short Sku,
    const unsigned short BclMajorVersion,
    const unsigned short BclMinorVersion,
    const unsigned short BclBuildNumber,
    const unsigned short BclQfeNumber,
    const unsigned short VMMajorVersion,
    const unsigned short VMMinorVersion,
    const unsigned short VMBuildNumber,
    const unsigned short VMQfeNumber,
    const unsigned int StartupFlags,
    const unsigned char StartupMode,
    PCWSTR CommandLine,
    const GUID* ComObjectGuid,
    PCWSTR RuntimeDllPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledRuntimeInformationStart())
        return ERROR_SUCCESS;

    char stackBuffer[153];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 153;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Sku, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BclMajorVersion, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BclMinorVersion, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BclBuildNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BclQfeNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VMMajorVersion, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VMMinorVersion, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VMBuildNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VMQfeNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StartupFlags, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(StartupMode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CommandLine, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(*ComObjectGuid, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RuntimeDllPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventRuntimeInformationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIncreaseMemoryPressure()
{
    return EventPipeEventIncreaseMemoryPressure->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIncreaseMemoryPressure(
    const unsigned __int64 BytesAllocated,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIncreaseMemoryPressure())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(BytesAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIncreaseMemoryPressure, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDecreaseMemoryPressure()
{
    return EventPipeEventDecreaseMemoryPressure->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDecreaseMemoryPressure(
    const unsigned __int64 BytesFreed,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDecreaseMemoryPressure())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(BytesFreed, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventDecreaseMemoryPressure, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCMarkWithType()
{
    return EventPipeEventGCMarkWithType->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCMarkWithType(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    const unsigned int Type,
    const unsigned __int64 Bytes,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCMarkWithType())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Bytes, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCMarkWithType, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCJoin_V2()
{
    return EventPipeEventGCJoin_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCJoin_V2(
    const unsigned int Heap,
    const unsigned int JoinTime,
    const unsigned int JoinType,
    const unsigned short ClrInstanceID,
    const unsigned int JoinID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCJoin_V2())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Heap, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinTime, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinType, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCJoin_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCPerHeapHistory_V3()
{
    return EventPipeEventGCPerHeapHistory_V3->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCPerHeapHistory_V3(
    const unsigned short ClrInstanceID,
    const void* FreeListAllocated,
    const void* FreeListRejected,
    const void* EndOfSegAllocated,
    const void* CondemnedAllocated,
    const void* PinnedAllocated,
    const void* PinnedAllocatedAdvance,
    const unsigned int RunningFreeListEfficiency,
    const unsigned int CondemnReasons0,
    const unsigned int CondemnReasons1,
    const unsigned int CompactMechanisms,
    const unsigned int ExpandMechanisms,
    const unsigned int HeapIndex,
    const void* ExtraGen0Commit,
    const unsigned int Count,
    int Values_ElementSize,
    const void* Values,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCPerHeapHistory_V3())
        return ERROR_SUCCESS;

    char stackBuffer[118];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 118;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FreeListAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FreeListRejected, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(EndOfSegAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnedAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PinnedAllocated, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PinnedAllocatedAdvance, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RunningFreeListEfficiency, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnReasons0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnReasons1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CompactMechanisms, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExpandMechanisms, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(HeapIndex, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ExtraGen0Commit, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Values, (int)Values_ElementSize * (int)Count, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCPerHeapHistory_V3, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCGlobalHeapHistory_V2()
{
    return EventPipeEventGCGlobalHeapHistory_V2->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCGlobalHeapHistory_V2(
    const unsigned __int64 FinalYoungestDesired,
    const signed int NumHeaps,
    const unsigned int CondemnedGeneration,
    const unsigned int Gen0ReductionCount,
    const unsigned int Reason,
    const unsigned int GlobalMechanisms,
    const unsigned short ClrInstanceID,
    const unsigned int PauseMode,
    const unsigned int MemoryPressure,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCGlobalHeapHistory_V2())
        return ERROR_SUCCESS;

    char stackBuffer[38];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 38;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(FinalYoungestDesired, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NumHeaps, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnedGeneration, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Gen0ReductionCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GlobalMechanisms, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PauseMode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MemoryPressure, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCGlobalHeapHistory_V2, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCGlobalHeapHistory_V3()
{
    return EventPipeEventGCGlobalHeapHistory_V3->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCGlobalHeapHistory_V3(
    const unsigned __int64 FinalYoungestDesired,
    const signed int NumHeaps,
    const unsigned int CondemnedGeneration,
    const unsigned int Gen0ReductionCount,
    const unsigned int Reason,
    const unsigned int GlobalMechanisms,
    const unsigned short ClrInstanceID,
    const unsigned int PauseMode,
    const unsigned int MemoryPressure,
    const unsigned int CondemnReasons0,
    const unsigned int CondemnReasons1,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCGlobalHeapHistory_V3())
        return ERROR_SUCCESS;

    char stackBuffer[46];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 46;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(FinalYoungestDesired, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NumHeaps, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnedGeneration, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Gen0ReductionCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GlobalMechanisms, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PauseMode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MemoryPressure, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnReasons0, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnReasons1, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCGlobalHeapHistory_V3, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGenAwareBegin()
{
    return EventPipeEventGenAwareBegin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGenAwareBegin(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGenAwareBegin())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGenAwareBegin, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGenAwareEnd()
{
    return EventPipeEventGenAwareEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGenAwareEnd(
    const unsigned int Count,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGenAwareEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Count, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGenAwareEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDebugIPCEventStart()
{
    return EventPipeEventDebugIPCEventStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDebugIPCEventStart(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDebugIPCEventStart())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDebugIPCEventStart, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDebugIPCEventEnd()
{
    return EventPipeEventDebugIPCEventEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDebugIPCEventEnd(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDebugIPCEventEnd())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDebugIPCEventEnd, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDebugExceptionProcessingStart()
{
    return EventPipeEventDebugExceptionProcessingStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDebugExceptionProcessingStart(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDebugExceptionProcessingStart())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDebugExceptionProcessingStart, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledDebugExceptionProcessingEnd()
{
    return EventPipeEventDebugExceptionProcessingEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventDebugExceptionProcessingEnd(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledDebugExceptionProcessingEnd())
        return ERROR_SUCCESS;
    EventPipe::WriteEvent(*EventPipeEventDebugExceptionProcessingEnd, (BYTE*) nullptr, 0, ActivityId, RelatedActivityId);

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCodeSymbols()
{
    return EventPipeEventCodeSymbols->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCodeSymbols(
    const unsigned __int64 ModuleId,
    const unsigned short TotalChunks,
    const unsigned short ChunkNumber,
    const unsigned int ChunkLength,
    const BYTE* Chunk,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCodeSymbols())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ModuleId, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TotalChunks, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ChunkNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ChunkLength, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer((const BYTE *)Chunk, sizeof(const BYTE) * (int)ChunkLength, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCodeSymbols, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEventSource()
{
    return EventPipeEventEventSource->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEventSource(
    const signed int EventID,
    PCWSTR EventName,
    PCWSTR EventSourceName,
    PCWSTR Payload,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEventSource())
        return ERROR_SUCCESS;

    char stackBuffer[196];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 196;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(EventID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(EventName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(EventSourceName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Payload, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEventSource, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTieredCompilationSettings()
{
    return EventPipeEventTieredCompilationSettings->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTieredCompilationSettings(
    const unsigned short ClrInstanceID,
    const unsigned int Flags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTieredCompilationSettings())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Flags, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTieredCompilationSettings, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTieredCompilationPause()
{
    return EventPipeEventTieredCompilationPause->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTieredCompilationPause(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTieredCompilationPause())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTieredCompilationPause, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTieredCompilationResume()
{
    return EventPipeEventTieredCompilationResume->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTieredCompilationResume(
    const unsigned short ClrInstanceID,
    const unsigned int NewMethodCount,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTieredCompilationResume())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewMethodCount, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTieredCompilationResume, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTieredCompilationBackgroundJitStart()
{
    return EventPipeEventTieredCompilationBackgroundJitStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTieredCompilationBackgroundJitStart(
    const unsigned short ClrInstanceID,
    const unsigned int PendingMethodCount,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTieredCompilationBackgroundJitStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PendingMethodCount, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTieredCompilationBackgroundJitStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTieredCompilationBackgroundJitStop()
{
    return EventPipeEventTieredCompilationBackgroundJitStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTieredCompilationBackgroundJitStop(
    const unsigned short ClrInstanceID,
    const unsigned int PendingMethodCount,
    const unsigned int JittedMethodCount,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTieredCompilationBackgroundJitStop())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PendingMethodCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JittedMethodCount, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTieredCompilationBackgroundJitStop, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyLoadStart()
{
    return EventPipeEventAssemblyLoadStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyLoadStart(
    const unsigned short ClrInstanceID,
    PCWSTR AssemblyName,
    PCWSTR AssemblyPath,
    PCWSTR RequestingAssembly,
    PCWSTR AssemblyLoadContext,
    PCWSTR RequestingAssemblyLoadContext,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyLoadStart())
        return ERROR_SUCCESS;

    char stackBuffer[322];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 322;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RequestingAssembly, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyLoadContext, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RequestingAssemblyLoadContext, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyLoadStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyLoadStop()
{
    return EventPipeEventAssemblyLoadStop->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyLoadStop(
    const unsigned short ClrInstanceID,
    PCWSTR AssemblyName,
    PCWSTR AssemblyPath,
    PCWSTR RequestingAssembly,
    PCWSTR AssemblyLoadContext,
    PCWSTR RequestingAssemblyLoadContext,
    const BOOL Success,
    PCWSTR ResultAssemblyName,
    PCWSTR ResultAssemblyPath,
    const BOOL Cached,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyLoadStop())
        return ERROR_SUCCESS;

    char stackBuffer[458];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 458;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RequestingAssembly, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyLoadContext, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RequestingAssemblyLoadContext, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Success, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ResultAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ResultAssemblyPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Cached, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyLoadStop, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledResolutionAttempted()
{
    return EventPipeEventResolutionAttempted->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventResolutionAttempted(
    const unsigned short ClrInstanceID,
    PCWSTR AssemblyName,
    const unsigned short Stage,
    PCWSTR AssemblyLoadContext,
    const unsigned short Result,
    PCWSTR ResultAssemblyName,
    PCWSTR ResultAssemblyPath,
    PCWSTR ErrorMessage,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledResolutionAttempted())
        return ERROR_SUCCESS;

    char stackBuffer[326];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 326;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Stage, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyLoadContext, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Result, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ResultAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ResultAssemblyPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorMessage, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventResolutionAttempted, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyLoadContextResolvingHandlerInvoked()
{
    return EventPipeEventAssemblyLoadContextResolvingHandlerInvoked->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyLoadContextResolvingHandlerInvoked(
    const unsigned short ClrInstanceID,
    PCWSTR AssemblyName,
    PCWSTR HandlerName,
    PCWSTR AssemblyLoadContext,
    PCWSTR ResultAssemblyName,
    PCWSTR ResultAssemblyPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyLoadContextResolvingHandlerInvoked())
        return ERROR_SUCCESS;

    char stackBuffer[322];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 322;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(HandlerName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyLoadContext, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ResultAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ResultAssemblyPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyLoadContextResolvingHandlerInvoked, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAppDomainAssemblyResolveHandlerInvoked()
{
    return EventPipeEventAppDomainAssemblyResolveHandlerInvoked->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAppDomainAssemblyResolveHandlerInvoked(
    const unsigned short ClrInstanceID,
    PCWSTR AssemblyName,
    PCWSTR HandlerName,
    PCWSTR ResultAssemblyName,
    PCWSTR ResultAssemblyPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAppDomainAssemblyResolveHandlerInvoked())
        return ERROR_SUCCESS;

    char stackBuffer[258];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 258;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(HandlerName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ResultAssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ResultAssemblyPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAppDomainAssemblyResolveHandlerInvoked, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAssemblyLoadFromResolveHandlerInvoked()
{
    return EventPipeEventAssemblyLoadFromResolveHandlerInvoked->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAssemblyLoadFromResolveHandlerInvoked(
    const unsigned short ClrInstanceID,
    PCWSTR AssemblyName,
    const BOOL IsTrackedLoad,
    PCWSTR RequestingAssemblyPath,
    PCWSTR ComputedRequestedAssemblyPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAssemblyLoadFromResolveHandlerInvoked())
        return ERROR_SUCCESS;

    char stackBuffer[198];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 198;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsTrackedLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RequestingAssemblyPath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ComputedRequestedAssemblyPath, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAssemblyLoadFromResolveHandlerInvoked, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledKnownPathProbed()
{
    return EventPipeEventKnownPathProbed->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventKnownPathProbed(
    const unsigned short ClrInstanceID,
    PCWSTR FilePath,
    const unsigned short Source,
    const signed int Result,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledKnownPathProbed())
        return ERROR_SUCCESS;

    char stackBuffer[72];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 72;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FilePath, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Source, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Result, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventKnownPathProbed, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

extern "C" void InitDotNETRuntime()
{
    EventPipeProviderDotNETRuntime = EventPipe::CreateProvider(SL(DotNETRuntimeName), EventPipeEtwCallbackDotNETRuntime);
    EventPipeEventGCStart = EventPipeProviderDotNETRuntime->AddEvent(1,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCStart_V1 = EventPipeProviderDotNETRuntime->AddEvent(1,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCStart_V2 = EventPipeProviderDotNETRuntime->AddEvent(1,1,2,EventPipeEventLevel::Informational,false);
    EventPipeEventGCEnd = EventPipeProviderDotNETRuntime->AddEvent(2,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCEnd_V1 = EventPipeProviderDotNETRuntime->AddEvent(2,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCRestartEEEnd = EventPipeProviderDotNETRuntime->AddEvent(3,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCRestartEEEnd_V1 = EventPipeProviderDotNETRuntime->AddEvent(3,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCHeapStats = EventPipeProviderDotNETRuntime->AddEvent(4,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCHeapStats_V1 = EventPipeProviderDotNETRuntime->AddEvent(4,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCHeapStats_V2 = EventPipeProviderDotNETRuntime->AddEvent(4,1,2,EventPipeEventLevel::Informational,false);
    EventPipeEventGCCreateSegment = EventPipeProviderDotNETRuntime->AddEvent(5,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCCreateSegment_V1 = EventPipeProviderDotNETRuntime->AddEvent(5,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCFreeSegment = EventPipeProviderDotNETRuntime->AddEvent(6,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCFreeSegment_V1 = EventPipeProviderDotNETRuntime->AddEvent(6,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCRestartEEBegin = EventPipeProviderDotNETRuntime->AddEvent(7,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCRestartEEBegin_V1 = EventPipeProviderDotNETRuntime->AddEvent(7,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCSuspendEEEnd = EventPipeProviderDotNETRuntime->AddEvent(8,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCSuspendEEEnd_V1 = EventPipeProviderDotNETRuntime->AddEvent(8,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCSuspendEEBegin = EventPipeProviderDotNETRuntime->AddEvent(9,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCSuspendEEBegin_V1 = EventPipeProviderDotNETRuntime->AddEvent(9,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCAllocationTick = EventPipeProviderDotNETRuntime->AddEvent(10,1,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCAllocationTick_V1 = EventPipeProviderDotNETRuntime->AddEvent(10,1,1,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCAllocationTick_V2 = EventPipeProviderDotNETRuntime->AddEvent(10,1,2,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCAllocationTick_V3 = EventPipeProviderDotNETRuntime->AddEvent(10,1,3,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCCreateConcurrentThread = EventPipeProviderDotNETRuntime->AddEvent(11,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCCreateConcurrentThread_V1 = EventPipeProviderDotNETRuntime->AddEvent(11,65537,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCTerminateConcurrentThread = EventPipeProviderDotNETRuntime->AddEvent(12,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCTerminateConcurrentThread_V1 = EventPipeProviderDotNETRuntime->AddEvent(12,65537,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCFinalizersEnd = EventPipeProviderDotNETRuntime->AddEvent(13,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCFinalizersEnd_V1 = EventPipeProviderDotNETRuntime->AddEvent(13,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventGCFinalizersBegin = EventPipeProviderDotNETRuntime->AddEvent(14,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCFinalizersBegin_V1 = EventPipeProviderDotNETRuntime->AddEvent(14,1,1,EventPipeEventLevel::Informational,false);
    EventPipeEventBulkType = EventPipeProviderDotNETRuntime->AddEvent(15,524288,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCBulkRootEdge = EventPipeProviderDotNETRuntime->AddEvent(16,1048576,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCBulkRootConditionalWeakTableElementEdge = EventPipeProviderDotNETRuntime->AddEvent(17,1048576,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCBulkNode = EventPipeProviderDotNETRuntime->AddEvent(18,1048576,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCBulkEdge = EventPipeProviderDotNETRuntime->AddEvent(19,1048576,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCSampledObjectAllocationHigh = EventPipeProviderDotNETRuntime->AddEvent(20,2097152,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGCBulkSurvivingObjectRanges = EventPipeProviderDotNETRuntime->AddEvent(21,4194304,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCBulkMovedObjectRanges = EventPipeProviderDotNETRuntime->AddEvent(22,4194304,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCGenerationRange = EventPipeProviderDotNETRuntime->AddEvent(23,4194304,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCMarkStackRoots = EventPipeProviderDotNETRuntime->AddEvent(25,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCMarkFinalizeQueueRoots = EventPipeProviderDotNETRuntime->AddEvent(26,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCMarkHandles = EventPipeProviderDotNETRuntime->AddEvent(27,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCMarkOlderGenerationRoots = EventPipeProviderDotNETRuntime->AddEvent(28,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventFinalizeObject = EventPipeProviderDotNETRuntime->AddEvent(29,1,0,EventPipeEventLevel::Verbose,false);
    EventPipeEventSetGCHandle = EventPipeProviderDotNETRuntime->AddEvent(30,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDestroyGCHandle = EventPipeProviderDotNETRuntime->AddEvent(31,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGCSampledObjectAllocationLow = EventPipeProviderDotNETRuntime->AddEvent(32,33554432,0,EventPipeEventLevel::Informational,true);
    EventPipeEventPinObjectAtGCTime = EventPipeProviderDotNETRuntime->AddEvent(33,1,0,EventPipeEventLevel::Verbose,false);
    EventPipeEventGCTriggered = EventPipeProviderDotNETRuntime->AddEvent(35,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGCBulkRootCCW = EventPipeProviderDotNETRuntime->AddEvent(36,1048576,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCBulkRCW = EventPipeProviderDotNETRuntime->AddEvent(37,1048576,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCBulkRootStaticVar = EventPipeProviderDotNETRuntime->AddEvent(38,1048576,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCDynamicEvent = EventPipeProviderDotNETRuntime->AddEvent(39,66060291,0,EventPipeEventLevel::LogAlways,true);
    EventPipeEventWorkerThreadCreate = EventPipeProviderDotNETRuntime->AddEvent(40,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventWorkerThreadTerminate = EventPipeProviderDotNETRuntime->AddEvent(41,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventWorkerThreadRetire = EventPipeProviderDotNETRuntime->AddEvent(42,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventWorkerThreadUnretire = EventPipeProviderDotNETRuntime->AddEvent(43,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventIOThreadCreate = EventPipeProviderDotNETRuntime->AddEvent(44,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventIOThreadCreate_V1 = EventPipeProviderDotNETRuntime->AddEvent(44,65536,1,EventPipeEventLevel::Informational,true);
    EventPipeEventIOThreadTerminate = EventPipeProviderDotNETRuntime->AddEvent(45,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventIOThreadTerminate_V1 = EventPipeProviderDotNETRuntime->AddEvent(45,65536,1,EventPipeEventLevel::Informational,true);
    EventPipeEventIOThreadRetire = EventPipeProviderDotNETRuntime->AddEvent(46,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventIOThreadRetire_V1 = EventPipeProviderDotNETRuntime->AddEvent(46,65536,1,EventPipeEventLevel::Informational,true);
    EventPipeEventIOThreadUnretire = EventPipeProviderDotNETRuntime->AddEvent(47,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventIOThreadUnretire_V1 = EventPipeProviderDotNETRuntime->AddEvent(47,65536,1,EventPipeEventLevel::Informational,true);
    EventPipeEventThreadpoolSuspensionSuspendThread = EventPipeProviderDotNETRuntime->AddEvent(48,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventThreadpoolSuspensionResumeThread = EventPipeProviderDotNETRuntime->AddEvent(49,65536,0,EventPipeEventLevel::Informational,true);
    EventPipeEventThreadPoolWorkerThreadStart = EventPipeProviderDotNETRuntime->AddEvent(50,65536,0,EventPipeEventLevel::Informational,false);
    EventPipeEventThreadPoolWorkerThreadStop = EventPipeProviderDotNETRuntime->AddEvent(51,65536,0,EventPipeEventLevel::Informational,false);
    EventPipeEventThreadPoolWorkerThreadRetirementStart = EventPipeProviderDotNETRuntime->AddEvent(52,65536,0,EventPipeEventLevel::Informational,false);
    EventPipeEventThreadPoolWorkerThreadRetirementStop = EventPipeProviderDotNETRuntime->AddEvent(53,65536,0,EventPipeEventLevel::Informational,false);
    EventPipeEventThreadPoolWorkerThreadAdjustmentSample = EventPipeProviderDotNETRuntime->AddEvent(54,65536,0,EventPipeEventLevel::Informational,false);
    EventPipeEventThreadPoolWorkerThreadAdjustmentAdjustment = EventPipeProviderDotNETRuntime->AddEvent(55,65536,0,EventPipeEventLevel::Informational,false);
    EventPipeEventThreadPoolWorkerThreadAdjustmentStats = EventPipeProviderDotNETRuntime->AddEvent(56,65536,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventThreadPoolWorkerThreadWait = EventPipeProviderDotNETRuntime->AddEvent(57,65536,0,EventPipeEventLevel::Informational,false);
    EventPipeEventThreadPoolWorkingThreadCount = EventPipeProviderDotNETRuntime->AddEvent(60,65536,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventThreadPoolEnqueue = EventPipeProviderDotNETRuntime->AddEvent(61,2147549184,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventThreadPoolDequeue = EventPipeProviderDotNETRuntime->AddEvent(62,2147549184,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventThreadPoolIOEnqueue = EventPipeProviderDotNETRuntime->AddEvent(63,2147549184,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventThreadPoolIODequeue = EventPipeProviderDotNETRuntime->AddEvent(64,2147549184,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventThreadPoolIOPack = EventPipeProviderDotNETRuntime->AddEvent(65,65536,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventThreadCreating = EventPipeProviderDotNETRuntime->AddEvent(70,2147549184,0,EventPipeEventLevel::Informational,true);
    EventPipeEventThreadRunning = EventPipeProviderDotNETRuntime->AddEvent(71,2147549184,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDetails = EventPipeProviderDotNETRuntime->AddEvent(72,274877906944,0,EventPipeEventLevel::Informational,false);
    EventPipeEventTypeLoadStart = EventPipeProviderDotNETRuntime->AddEvent(73,549755813888,0,EventPipeEventLevel::Informational,true);
    EventPipeEventTypeLoadStop = EventPipeProviderDotNETRuntime->AddEvent(74,549755813888,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExceptionThrown = EventPipeProviderDotNETRuntime->AddEvent(80,0,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExceptionThrown_V1 = EventPipeProviderDotNETRuntime->AddEvent(80,8589967360,1,EventPipeEventLevel::Error,true);
    EventPipeEventExceptionCatchStart = EventPipeProviderDotNETRuntime->AddEvent(250,32768,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExceptionCatchStop = EventPipeProviderDotNETRuntime->AddEvent(251,32768,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExceptionFinallyStart = EventPipeProviderDotNETRuntime->AddEvent(252,32768,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExceptionFinallyStop = EventPipeProviderDotNETRuntime->AddEvent(253,32768,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExceptionFilterStart = EventPipeProviderDotNETRuntime->AddEvent(254,32768,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExceptionFilterStop = EventPipeProviderDotNETRuntime->AddEvent(255,32768,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExceptionThrownStop = EventPipeProviderDotNETRuntime->AddEvent(256,32768,0,EventPipeEventLevel::Informational,true);
    EventPipeEventContention = EventPipeProviderDotNETRuntime->AddEvent(81,0,0,EventPipeEventLevel::Informational,true);
    EventPipeEventContentionStart_V1 = EventPipeProviderDotNETRuntime->AddEvent(81,16384,1,EventPipeEventLevel::Informational,true);
    EventPipeEventContentionStop = EventPipeProviderDotNETRuntime->AddEvent(91,16384,0,EventPipeEventLevel::Informational,false);
    EventPipeEventContentionStop_V1 = EventPipeProviderDotNETRuntime->AddEvent(91,16384,1,EventPipeEventLevel::Informational,false);
    EventPipeEventCLRStackWalk = EventPipeProviderDotNETRuntime->AddEvent(82,1073741824,0,EventPipeEventLevel::LogAlways,false);
    EventPipeEventAppDomainMemAllocated = EventPipeProviderDotNETRuntime->AddEvent(83,2048,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainMemSurvived = EventPipeProviderDotNETRuntime->AddEvent(84,2048,0,EventPipeEventLevel::Informational,true);
    EventPipeEventThreadCreated = EventPipeProviderDotNETRuntime->AddEvent(85,67584,0,EventPipeEventLevel::Informational,true);
    EventPipeEventThreadTerminated = EventPipeProviderDotNETRuntime->AddEvent(86,67584,0,EventPipeEventLevel::Informational,true);
    EventPipeEventThreadDomainEnter = EventPipeProviderDotNETRuntime->AddEvent(87,67584,0,EventPipeEventLevel::Informational,true);
    EventPipeEventILStubGenerated = EventPipeProviderDotNETRuntime->AddEvent(88,8192,0,EventPipeEventLevel::Informational,true);
    EventPipeEventILStubCacheHit = EventPipeProviderDotNETRuntime->AddEvent(89,8192,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDCStartCompleteV2 = EventPipeProviderDotNETRuntime->AddEvent(135,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDCEndCompleteV2 = EventPipeProviderDotNETRuntime->AddEvent(136,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCStartV2 = EventPipeProviderDotNETRuntime->AddEvent(137,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCEndV2 = EventPipeProviderDotNETRuntime->AddEvent(138,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCStartVerboseV2 = EventPipeProviderDotNETRuntime->AddEvent(139,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodDCEndVerboseV2 = EventPipeProviderDotNETRuntime->AddEvent(140,48,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodLoad = EventPipeProviderDotNETRuntime->AddEvent(141,48,0,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodLoad_V1 = EventPipeProviderDotNETRuntime->AddEvent(141,48,1,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodLoad_V2 = EventPipeProviderDotNETRuntime->AddEvent(141,48,2,EventPipeEventLevel::Informational,false);
    EventPipeEventR2RGetEntryPoint = EventPipeProviderDotNETRuntime->AddEvent(159,137438953472,0,EventPipeEventLevel::Informational,true);
    EventPipeEventR2RGetEntryPointStart = EventPipeProviderDotNETRuntime->AddEvent(160,137438953472,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodUnload = EventPipeProviderDotNETRuntime->AddEvent(142,48,0,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodUnload_V1 = EventPipeProviderDotNETRuntime->AddEvent(142,48,1,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodUnload_V2 = EventPipeProviderDotNETRuntime->AddEvent(142,48,2,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodLoadVerbose = EventPipeProviderDotNETRuntime->AddEvent(143,48,0,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodLoadVerbose_V1 = EventPipeProviderDotNETRuntime->AddEvent(143,48,1,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodLoadVerbose_V2 = EventPipeProviderDotNETRuntime->AddEvent(143,48,2,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodUnloadVerbose = EventPipeProviderDotNETRuntime->AddEvent(144,48,0,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodUnloadVerbose_V1 = EventPipeProviderDotNETRuntime->AddEvent(144,48,1,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodUnloadVerbose_V2 = EventPipeProviderDotNETRuntime->AddEvent(144,48,2,EventPipeEventLevel::Informational,false);
    EventPipeEventMethodJittingStarted = EventPipeProviderDotNETRuntime->AddEvent(145,16,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventMethodJittingStarted_V1 = EventPipeProviderDotNETRuntime->AddEvent(145,16,1,EventPipeEventLevel::Verbose,true);
    EventPipeEventMethodJitInliningSucceeded = EventPipeProviderDotNETRuntime->AddEvent(185,4096,0,EventPipeEventLevel::Verbose,false);
    EventPipeEventMethodJitInliningFailedAnsi = EventPipeProviderDotNETRuntime->AddEvent(186,4096,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventMethodJitTailCallSucceeded = EventPipeProviderDotNETRuntime->AddEvent(188,4096,0,EventPipeEventLevel::Verbose,false);
    EventPipeEventMethodJitTailCallFailedAnsi = EventPipeProviderDotNETRuntime->AddEvent(189,4096,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventMethodILToNativeMap = EventPipeProviderDotNETRuntime->AddEvent(190,131072,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventMethodJitTailCallFailed = EventPipeProviderDotNETRuntime->AddEvent(191,4096,0,EventPipeEventLevel::Verbose,false);
    EventPipeEventMethodJitInliningFailed = EventPipeProviderDotNETRuntime->AddEvent(192,4096,0,EventPipeEventLevel::Verbose,false);
    EventPipeEventModuleDCStartV2 = EventPipeProviderDotNETRuntime->AddEvent(149,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleDCEndV2 = EventPipeProviderDotNETRuntime->AddEvent(150,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDomainModuleLoad = EventPipeProviderDotNETRuntime->AddEvent(151,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDomainModuleLoad_V1 = EventPipeProviderDotNETRuntime->AddEvent(151,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleLoad = EventPipeProviderDotNETRuntime->AddEvent(152,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleLoad_V1 = EventPipeProviderDotNETRuntime->AddEvent(152,536870920,1,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleLoad_V2 = EventPipeProviderDotNETRuntime->AddEvent(152,536870920,2,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleUnload = EventPipeProviderDotNETRuntime->AddEvent(153,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleUnload_V1 = EventPipeProviderDotNETRuntime->AddEvent(153,536870920,1,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleUnload_V2 = EventPipeProviderDotNETRuntime->AddEvent(153,536870920,2,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyLoad = EventPipeProviderDotNETRuntime->AddEvent(154,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyLoad_V1 = EventPipeProviderDotNETRuntime->AddEvent(154,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyUnload = EventPipeProviderDotNETRuntime->AddEvent(155,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyUnload_V1 = EventPipeProviderDotNETRuntime->AddEvent(155,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainLoad = EventPipeProviderDotNETRuntime->AddEvent(156,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainLoad_V1 = EventPipeProviderDotNETRuntime->AddEvent(156,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainUnload = EventPipeProviderDotNETRuntime->AddEvent(157,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainUnload_V1 = EventPipeProviderDotNETRuntime->AddEvent(157,8,1,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleRangeLoad = EventPipeProviderDotNETRuntime->AddEvent(158,536870912,0,EventPipeEventLevel::Informational,false);
    EventPipeEventStrongNameVerificationStart = EventPipeProviderDotNETRuntime->AddEvent(181,1024,0,EventPipeEventLevel::Verbose,false);
    EventPipeEventStrongNameVerificationStart_V1 = EventPipeProviderDotNETRuntime->AddEvent(181,1024,1,EventPipeEventLevel::Verbose,false);
    EventPipeEventStrongNameVerificationStop = EventPipeProviderDotNETRuntime->AddEvent(182,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventStrongNameVerificationStop_V1 = EventPipeProviderDotNETRuntime->AddEvent(182,1024,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAuthenticodeVerificationStart = EventPipeProviderDotNETRuntime->AddEvent(183,1024,0,EventPipeEventLevel::Verbose,false);
    EventPipeEventAuthenticodeVerificationStart_V1 = EventPipeProviderDotNETRuntime->AddEvent(183,1024,1,EventPipeEventLevel::Verbose,false);
    EventPipeEventAuthenticodeVerificationStop = EventPipeProviderDotNETRuntime->AddEvent(184,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAuthenticodeVerificationStop_V1 = EventPipeProviderDotNETRuntime->AddEvent(184,1024,1,EventPipeEventLevel::Informational,true);
    EventPipeEventRuntimeInformationStart = EventPipeProviderDotNETRuntime->AddEvent(187,0,0,EventPipeEventLevel::Informational,false);
    EventPipeEventIncreaseMemoryPressure = EventPipeProviderDotNETRuntime->AddEvent(200,1,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventDecreaseMemoryPressure = EventPipeProviderDotNETRuntime->AddEvent(201,1,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCMarkWithType = EventPipeProviderDotNETRuntime->AddEvent(202,1,0,EventPipeEventLevel::Informational,false);
    EventPipeEventGCJoin_V2 = EventPipeProviderDotNETRuntime->AddEvent(203,1,2,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCPerHeapHistory_V3 = EventPipeProviderDotNETRuntime->AddEvent(204,1,3,EventPipeEventLevel::Informational,false);
    EventPipeEventGCGlobalHeapHistory_V2 = EventPipeProviderDotNETRuntime->AddEvent(205,1,2,EventPipeEventLevel::Informational,true);
    EventPipeEventGCGlobalHeapHistory_V3 = EventPipeProviderDotNETRuntime->AddEvent(205,1,3,EventPipeEventLevel::Informational,true);
    EventPipeEventGenAwareBegin = EventPipeProviderDotNETRuntime->AddEvent(206,1048576,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGenAwareEnd = EventPipeProviderDotNETRuntime->AddEvent(207,1048576,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDebugIPCEventStart = EventPipeProviderDotNETRuntime->AddEvent(240,4294967296,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDebugIPCEventEnd = EventPipeProviderDotNETRuntime->AddEvent(241,4294967296,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDebugExceptionProcessingStart = EventPipeProviderDotNETRuntime->AddEvent(242,4294967296,0,EventPipeEventLevel::Informational,true);
    EventPipeEventDebugExceptionProcessingEnd = EventPipeProviderDotNETRuntime->AddEvent(243,4294967296,0,EventPipeEventLevel::Informational,true);
    EventPipeEventCodeSymbols = EventPipeProviderDotNETRuntime->AddEvent(260,17179869184,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventEventSource = EventPipeProviderDotNETRuntime->AddEvent(270,34359738368,0,EventPipeEventLevel::Informational,true);
    EventPipeEventTieredCompilationSettings = EventPipeProviderDotNETRuntime->AddEvent(280,68719476736,0,EventPipeEventLevel::Informational,false);
    EventPipeEventTieredCompilationPause = EventPipeProviderDotNETRuntime->AddEvent(281,68719476736,0,EventPipeEventLevel::Informational,false);
    EventPipeEventTieredCompilationResume = EventPipeProviderDotNETRuntime->AddEvent(282,68719476736,0,EventPipeEventLevel::Informational,false);
    EventPipeEventTieredCompilationBackgroundJitStart = EventPipeProviderDotNETRuntime->AddEvent(283,68719476736,0,EventPipeEventLevel::Informational,false);
    EventPipeEventTieredCompilationBackgroundJitStop = EventPipeProviderDotNETRuntime->AddEvent(284,68719476736,0,EventPipeEventLevel::Informational,false);
    EventPipeEventAssemblyLoadStart = EventPipeProviderDotNETRuntime->AddEvent(290,4,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyLoadStop = EventPipeProviderDotNETRuntime->AddEvent(291,4,0,EventPipeEventLevel::Informational,true);
    EventPipeEventResolutionAttempted = EventPipeProviderDotNETRuntime->AddEvent(292,4,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyLoadContextResolvingHandlerInvoked = EventPipeProviderDotNETRuntime->AddEvent(293,4,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAppDomainAssemblyResolveHandlerInvoked = EventPipeProviderDotNETRuntime->AddEvent(294,4,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAssemblyLoadFromResolveHandlerInvoked = EventPipeProviderDotNETRuntime->AddEvent(295,4,0,EventPipeEventLevel::Informational,true);
    EventPipeEventKnownPathProbed = EventPipeProviderDotNETRuntime->AddEvent(296,4,0,EventPipeEventLevel::Informational,true);
}
