// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventPipe.py

******************************************************************/


#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/common.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipeprovider.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipeevent.h"
#include "/builddir/build/BUILD/dotnet-v5.0.210-SDK/src/dotnet-runtime.b3afe992253738208ccaaa058e726553889928de/src/coreclr/src/vm/eventpipe.h"

#if defined(TARGET_UNIX)
#define wcslen PAL_wcslen
#endif

bool ResizeBuffer(char *&buffer, size_t& size, size_t currLen, size_t newSize, bool &fixedBuffer);
bool WriteToBuffer(PCWSTR str, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const char *str, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);
bool WriteToBuffer(const BYTE *src, size_t len, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer);

template <typename T>
bool WriteToBuffer(const T &value, char *&buffer, size_t& offset, size_t& size, bool &fixedBuffer)
{
    if (sizeof(T) + offset > size)
    {
        if (!ResizeBuffer(buffer, size, offset, size + sizeof(T), fixedBuffer))
            return false;
    }

    memcpy(buffer + offset, (char *)&value, sizeof(T));
    offset += sizeof(T);
    return true;
}

const WCHAR* DotNETRuntimePrivateName = W("Microsoft-Windows-DotNETRuntimePrivate");
EventPipeProvider *EventPipeProviderDotNETRuntimePrivate = nullptr;
EventPipeEvent *EventPipeEventGCDecision = nullptr;
EventPipeEvent *EventPipeEventGCDecision_V1 = nullptr;
EventPipeEvent *EventPipeEventGCSettings = nullptr;
EventPipeEvent *EventPipeEventGCSettings_V1 = nullptr;
EventPipeEvent *EventPipeEventGCOptimized = nullptr;
EventPipeEvent *EventPipeEventGCOptimized_V1 = nullptr;
EventPipeEvent *EventPipeEventGCPerHeapHistory = nullptr;
EventPipeEvent *EventPipeEventGCPerHeapHistory_V1 = nullptr;
EventPipeEvent *EventPipeEventGCGlobalHeapHistory = nullptr;
EventPipeEvent *EventPipeEventGCGlobalHeapHistory_V1 = nullptr;
EventPipeEvent *EventPipeEventGCJoin = nullptr;
EventPipeEvent *EventPipeEventGCJoin_V1 = nullptr;
EventPipeEvent *EventPipeEventPrvGCMarkStackRoots = nullptr;
EventPipeEvent *EventPipeEventPrvGCMarkStackRoots_V1 = nullptr;
EventPipeEvent *EventPipeEventPrvGCMarkFinalizeQueueRoots = nullptr;
EventPipeEvent *EventPipeEventPrvGCMarkFinalizeQueueRoots_V1 = nullptr;
EventPipeEvent *EventPipeEventPrvGCMarkHandles = nullptr;
EventPipeEvent *EventPipeEventPrvGCMarkHandles_V1 = nullptr;
EventPipeEvent *EventPipeEventPrvGCMarkCards = nullptr;
EventPipeEvent *EventPipeEventPrvGCMarkCards_V1 = nullptr;
EventPipeEvent *EventPipeEventBGCBegin = nullptr;
EventPipeEvent *EventPipeEventBGC1stNonConEnd = nullptr;
EventPipeEvent *EventPipeEventBGC1stConEnd = nullptr;
EventPipeEvent *EventPipeEventBGC2ndNonConBegin = nullptr;
EventPipeEvent *EventPipeEventBGC2ndNonConEnd = nullptr;
EventPipeEvent *EventPipeEventBGC2ndConBegin = nullptr;
EventPipeEvent *EventPipeEventBGC2ndConEnd = nullptr;
EventPipeEvent *EventPipeEventBGCPlanEnd = nullptr;
EventPipeEvent *EventPipeEventBGCSweepEnd = nullptr;
EventPipeEvent *EventPipeEventBGCDrainMark = nullptr;
EventPipeEvent *EventPipeEventBGCRevisit = nullptr;
EventPipeEvent *EventPipeEventBGCOverflow = nullptr;
EventPipeEvent *EventPipeEventBGCOverflow_V1 = nullptr;
EventPipeEvent *EventPipeEventBGCAllocWaitBegin = nullptr;
EventPipeEvent *EventPipeEventBGCAllocWaitEnd = nullptr;
EventPipeEvent *EventPipeEventGCFullNotify = nullptr;
EventPipeEvent *EventPipeEventGCFullNotify_V1 = nullptr;
EventPipeEvent *EventPipeEventBGC1stSweepEnd = nullptr;
EventPipeEvent *EventPipeEventEEStartupStart = nullptr;
EventPipeEvent *EventPipeEventEEStartupStart_V1 = nullptr;
EventPipeEvent *EventPipeEventEEStartupEnd = nullptr;
EventPipeEvent *EventPipeEventEEStartupEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventEEConfigSetup = nullptr;
EventPipeEvent *EventPipeEventEEConfigSetup_V1 = nullptr;
EventPipeEvent *EventPipeEventEEConfigSetupEnd = nullptr;
EventPipeEvent *EventPipeEventEEConfigSetupEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventLdSysBases = nullptr;
EventPipeEvent *EventPipeEventLdSysBases_V1 = nullptr;
EventPipeEvent *EventPipeEventLdSysBasesEnd = nullptr;
EventPipeEvent *EventPipeEventLdSysBasesEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventExecExe = nullptr;
EventPipeEvent *EventPipeEventExecExe_V1 = nullptr;
EventPipeEvent *EventPipeEventExecExeEnd = nullptr;
EventPipeEvent *EventPipeEventExecExeEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventMain = nullptr;
EventPipeEvent *EventPipeEventMain_V1 = nullptr;
EventPipeEvent *EventPipeEventMainEnd = nullptr;
EventPipeEvent *EventPipeEventMainEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventApplyPolicyStart = nullptr;
EventPipeEvent *EventPipeEventApplyPolicyStart_V1 = nullptr;
EventPipeEvent *EventPipeEventApplyPolicyEnd = nullptr;
EventPipeEvent *EventPipeEventApplyPolicyEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventLdLibShFolder = nullptr;
EventPipeEvent *EventPipeEventLdLibShFolder_V1 = nullptr;
EventPipeEvent *EventPipeEventLdLibShFolderEnd = nullptr;
EventPipeEvent *EventPipeEventLdLibShFolderEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventPrestubWorker = nullptr;
EventPipeEvent *EventPipeEventPrestubWorker_V1 = nullptr;
EventPipeEvent *EventPipeEventPrestubWorkerEnd = nullptr;
EventPipeEvent *EventPipeEventPrestubWorkerEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventGetInstallationStart = nullptr;
EventPipeEvent *EventPipeEventGetInstallationStart_V1 = nullptr;
EventPipeEvent *EventPipeEventGetInstallationEnd = nullptr;
EventPipeEvent *EventPipeEventGetInstallationEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventOpenHModule = nullptr;
EventPipeEvent *EventPipeEventOpenHModule_V1 = nullptr;
EventPipeEvent *EventPipeEventOpenHModuleEnd = nullptr;
EventPipeEvent *EventPipeEventOpenHModuleEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventExplicitBindStart = nullptr;
EventPipeEvent *EventPipeEventExplicitBindStart_V1 = nullptr;
EventPipeEvent *EventPipeEventExplicitBindEnd = nullptr;
EventPipeEvent *EventPipeEventExplicitBindEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventParseXml = nullptr;
EventPipeEvent *EventPipeEventParseXml_V1 = nullptr;
EventPipeEvent *EventPipeEventParseXmlEnd = nullptr;
EventPipeEvent *EventPipeEventParseXmlEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventInitDefaultDomain = nullptr;
EventPipeEvent *EventPipeEventInitDefaultDomain_V1 = nullptr;
EventPipeEvent *EventPipeEventInitDefaultDomainEnd = nullptr;
EventPipeEvent *EventPipeEventInitDefaultDomainEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventInitSecurity = nullptr;
EventPipeEvent *EventPipeEventInitSecurity_V1 = nullptr;
EventPipeEvent *EventPipeEventInitSecurityEnd = nullptr;
EventPipeEvent *EventPipeEventInitSecurityEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventAllowBindingRedirs = nullptr;
EventPipeEvent *EventPipeEventAllowBindingRedirs_V1 = nullptr;
EventPipeEvent *EventPipeEventAllowBindingRedirsEnd = nullptr;
EventPipeEvent *EventPipeEventAllowBindingRedirsEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventEEConfigSync = nullptr;
EventPipeEvent *EventPipeEventEEConfigSync_V1 = nullptr;
EventPipeEvent *EventPipeEventEEConfigSyncEnd = nullptr;
EventPipeEvent *EventPipeEventEEConfigSyncEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventFusionBinding = nullptr;
EventPipeEvent *EventPipeEventFusionBinding_V1 = nullptr;
EventPipeEvent *EventPipeEventFusionBindingEnd = nullptr;
EventPipeEvent *EventPipeEventFusionBindingEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventLoaderCatchCall = nullptr;
EventPipeEvent *EventPipeEventLoaderCatchCall_V1 = nullptr;
EventPipeEvent *EventPipeEventLoaderCatchCallEnd = nullptr;
EventPipeEvent *EventPipeEventLoaderCatchCallEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventFusionInit = nullptr;
EventPipeEvent *EventPipeEventFusionInit_V1 = nullptr;
EventPipeEvent *EventPipeEventFusionInitEnd = nullptr;
EventPipeEvent *EventPipeEventFusionInitEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventFusionAppCtx = nullptr;
EventPipeEvent *EventPipeEventFusionAppCtx_V1 = nullptr;
EventPipeEvent *EventPipeEventFusionAppCtxEnd = nullptr;
EventPipeEvent *EventPipeEventFusionAppCtxEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventFusion2EE = nullptr;
EventPipeEvent *EventPipeEventFusion2EE_V1 = nullptr;
EventPipeEvent *EventPipeEventFusion2EEEnd = nullptr;
EventPipeEvent *EventPipeEventFusion2EEEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventSecurityCatchCall = nullptr;
EventPipeEvent *EventPipeEventSecurityCatchCall_V1 = nullptr;
EventPipeEvent *EventPipeEventSecurityCatchCallEnd = nullptr;
EventPipeEvent *EventPipeEventSecurityCatchCallEnd_V1 = nullptr;
EventPipeEvent *EventPipeEventCLRStackWalkPrivate = nullptr;
EventPipeEvent *EventPipeEventModuleRangeLoadPrivate = nullptr;
EventPipeEvent *EventPipeEventBindingPolicyPhaseStart = nullptr;
EventPipeEvent *EventPipeEventBindingPolicyPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventBindingNgenPhaseStart = nullptr;
EventPipeEvent *EventPipeEventBindingNgenPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventBindingLookupAndProbingPhaseStart = nullptr;
EventPipeEvent *EventPipeEventBindingLookupAndProbingPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventLoaderPhaseStart = nullptr;
EventPipeEvent *EventPipeEventLoaderPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventBindingPhaseStart = nullptr;
EventPipeEvent *EventPipeEventBindingPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventBindingDownloadPhaseStart = nullptr;
EventPipeEvent *EventPipeEventBindingDownloadPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventLoaderAssemblyInitPhaseStart = nullptr;
EventPipeEvent *EventPipeEventLoaderAssemblyInitPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventLoaderMappingPhaseStart = nullptr;
EventPipeEvent *EventPipeEventLoaderMappingPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventLoaderDeliverEventsPhaseStart = nullptr;
EventPipeEvent *EventPipeEventLoaderDeliverEventsPhaseEnd = nullptr;
EventPipeEvent *EventPipeEventEvidenceGenerated = nullptr;
EventPipeEvent *EventPipeEventModuleTransparencyComputationStart = nullptr;
EventPipeEvent *EventPipeEventModuleTransparencyComputationEnd = nullptr;
EventPipeEvent *EventPipeEventTypeTransparencyComputationStart = nullptr;
EventPipeEvent *EventPipeEventTypeTransparencyComputationEnd = nullptr;
EventPipeEvent *EventPipeEventMethodTransparencyComputationStart = nullptr;
EventPipeEvent *EventPipeEventMethodTransparencyComputationEnd = nullptr;
EventPipeEvent *EventPipeEventFieldTransparencyComputationStart = nullptr;
EventPipeEvent *EventPipeEventFieldTransparencyComputationEnd = nullptr;
EventPipeEvent *EventPipeEventTokenTransparencyComputationStart = nullptr;
EventPipeEvent *EventPipeEventTokenTransparencyComputationEnd = nullptr;
EventPipeEvent *EventPipeEventNgenBindEvent = nullptr;
EventPipeEvent *EventPipeEventFailFast = nullptr;
EventPipeEvent *EventPipeEventPrvFinalizeObject = nullptr;
EventPipeEvent *EventPipeEventCCWRefCountChangeAnsi = nullptr;
EventPipeEvent *EventPipeEventPrvSetGCHandle = nullptr;
EventPipeEvent *EventPipeEventPrvDestroyGCHandle = nullptr;
EventPipeEvent *EventPipeEventFusionMessageEvent = nullptr;
EventPipeEvent *EventPipeEventFusionErrorCodeEvent = nullptr;
EventPipeEvent *EventPipeEventPinPlugAtGCTime = nullptr;
EventPipeEvent *EventPipeEventCCWRefCountChange = nullptr;
EventPipeEvent *EventPipeEventAllocRequest = nullptr;
EventPipeEvent *EventPipeEventMulticoreJit = nullptr;
EventPipeEvent *EventPipeEventMulticoreJitMethodCodeReturned = nullptr;
EventPipeEvent *EventPipeEventIInspectableRuntimeClassName = nullptr;
EventPipeEvent *EventPipeEventWinRTUnbox = nullptr;
EventPipeEvent *EventPipeEventCreateRCW = nullptr;
EventPipeEvent *EventPipeEventRCWVariance = nullptr;
EventPipeEvent *EventPipeEventRCWIEnumerableCasting = nullptr;
EventPipeEvent *EventPipeEventCreateCCW = nullptr;
EventPipeEvent *EventPipeEventCCWVariance = nullptr;
EventPipeEvent *EventPipeEventObjectVariantMarshallingToNative = nullptr;
EventPipeEvent *EventPipeEventGetTypeFromGUID = nullptr;
EventPipeEvent *EventPipeEventGetTypeFromProgID = nullptr;
EventPipeEvent *EventPipeEventConvertToCallbackEtw = nullptr;
EventPipeEvent *EventPipeEventBeginCreateManagedReference = nullptr;
EventPipeEvent *EventPipeEventEndCreateManagedReference = nullptr;
EventPipeEvent *EventPipeEventObjectVariantMarshallingToManaged = nullptr;
BOOL EventPipeEventEnabledGCDecision()
{
    return EventPipeEventGCDecision->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCDecision(
    const BOOL DoCompact,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCDecision())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(DoCompact, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCDecision, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCDecision_V1()
{
    return EventPipeEventGCDecision_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCDecision_V1(
    const BOOL DoCompact,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCDecision_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(DoCompact, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCDecision_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSettings()
{
    return EventPipeEventGCSettings->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCSettings(
    const unsigned __int64 SegmentSize,
    const unsigned __int64 LargeObjectSegmentSize,
    const BOOL ServerGC,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSettings())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(SegmentSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LargeObjectSegmentSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ServerGC, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCSettings, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCSettings_V1()
{
    return EventPipeEventGCSettings_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCSettings_V1(
    const unsigned __int64 SegmentSize,
    const unsigned __int64 LargeObjectSegmentSize,
    const BOOL ServerGC,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCSettings_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(SegmentSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LargeObjectSegmentSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ServerGC, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCSettings_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCOptimized()
{
    return EventPipeEventGCOptimized->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCOptimized(
    const unsigned __int64 DesiredAllocation,
    const unsigned __int64 NewAllocation,
    const unsigned int GenerationNumber,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCOptimized())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(DesiredAllocation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewAllocation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationNumber, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCOptimized, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCOptimized_V1()
{
    return EventPipeEventGCOptimized_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCOptimized_V1(
    const unsigned __int64 DesiredAllocation,
    const unsigned __int64 NewAllocation,
    const unsigned int GenerationNumber,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCOptimized_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(DesiredAllocation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewAllocation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenerationNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCOptimized_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCPerHeapHistory()
{
    return EventPipeEventGCPerHeapHistory->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCPerHeapHistory(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCPerHeapHistory())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCPerHeapHistory, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCPerHeapHistory_V1()
{
    return EventPipeEventGCPerHeapHistory_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCPerHeapHistory_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCPerHeapHistory_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCPerHeapHistory_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCGlobalHeapHistory()
{
    return EventPipeEventGCGlobalHeapHistory->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCGlobalHeapHistory(
    const unsigned __int64 FinalYoungestDesired,
    const signed int NumHeaps,
    const unsigned int CondemnedGeneration,
    const unsigned int Gen0ReductionCount,
    const unsigned int Reason,
    const unsigned int GlobalMechanisms,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCGlobalHeapHistory())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(FinalYoungestDesired, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NumHeaps, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnedGeneration, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Gen0ReductionCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GlobalMechanisms, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCGlobalHeapHistory, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCGlobalHeapHistory_V1()
{
    return EventPipeEventGCGlobalHeapHistory_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCGlobalHeapHistory_V1(
    const unsigned __int64 FinalYoungestDesired,
    const signed int NumHeaps,
    const unsigned int CondemnedGeneration,
    const unsigned int Gen0ReductionCount,
    const unsigned int Reason,
    const unsigned int GlobalMechanisms,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCGlobalHeapHistory_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(FinalYoungestDesired, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NumHeaps, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(CondemnedGeneration, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Gen0ReductionCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GlobalMechanisms, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCGlobalHeapHistory_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCJoin()
{
    return EventPipeEventGCJoin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCJoin(
    const unsigned int Heap,
    const unsigned int JoinTime,
    const unsigned int JoinType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCJoin())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Heap, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinTime, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinType, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCJoin, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCJoin_V1()
{
    return EventPipeEventGCJoin_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCJoin_V1(
    const unsigned int Heap,
    const unsigned int JoinTime,
    const unsigned int JoinType,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCJoin_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Heap, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinTime, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(JoinType, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCJoin_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvGCMarkStackRoots()
{
    return EventPipeEventPrvGCMarkStackRoots->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvGCMarkStackRoots(
    const unsigned int HeapNum,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvGCMarkStackRoots())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvGCMarkStackRoots, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvGCMarkStackRoots_V1()
{
    return EventPipeEventPrvGCMarkStackRoots_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvGCMarkStackRoots_V1(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvGCMarkStackRoots_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvGCMarkStackRoots_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvGCMarkFinalizeQueueRoots()
{
    return EventPipeEventPrvGCMarkFinalizeQueueRoots->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvGCMarkFinalizeQueueRoots(
    const unsigned int HeapNum,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvGCMarkFinalizeQueueRoots())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvGCMarkFinalizeQueueRoots, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvGCMarkFinalizeQueueRoots_V1()
{
    return EventPipeEventPrvGCMarkFinalizeQueueRoots_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvGCMarkFinalizeQueueRoots_V1(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvGCMarkFinalizeQueueRoots_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvGCMarkFinalizeQueueRoots_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvGCMarkHandles()
{
    return EventPipeEventPrvGCMarkHandles->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvGCMarkHandles(
    const unsigned int HeapNum,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvGCMarkHandles())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvGCMarkHandles, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvGCMarkHandles_V1()
{
    return EventPipeEventPrvGCMarkHandles_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvGCMarkHandles_V1(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvGCMarkHandles_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvGCMarkHandles_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvGCMarkCards()
{
    return EventPipeEventPrvGCMarkCards->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvGCMarkCards(
    const unsigned int HeapNum,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvGCMarkCards())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvGCMarkCards, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvGCMarkCards_V1()
{
    return EventPipeEventPrvGCMarkCards_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvGCMarkCards_V1(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvGCMarkCards_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HeapNum, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvGCMarkCards_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCBegin()
{
    return EventPipeEventBGCBegin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCBegin(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCBegin())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCBegin, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGC1stNonConEnd()
{
    return EventPipeEventBGC1stNonConEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGC1stNonConEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGC1stNonConEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGC1stNonConEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGC1stConEnd()
{
    return EventPipeEventBGC1stConEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGC1stConEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGC1stConEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGC1stConEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGC2ndNonConBegin()
{
    return EventPipeEventBGC2ndNonConBegin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGC2ndNonConBegin(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGC2ndNonConBegin())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGC2ndNonConBegin, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGC2ndNonConEnd()
{
    return EventPipeEventBGC2ndNonConEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGC2ndNonConEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGC2ndNonConEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGC2ndNonConEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGC2ndConBegin()
{
    return EventPipeEventBGC2ndConBegin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGC2ndConBegin(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGC2ndConBegin())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGC2ndConBegin, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGC2ndConEnd()
{
    return EventPipeEventBGC2ndConEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGC2ndConEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGC2ndConEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGC2ndConEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCPlanEnd()
{
    return EventPipeEventBGCPlanEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCPlanEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCPlanEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCPlanEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCSweepEnd()
{
    return EventPipeEventBGCSweepEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCSweepEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCSweepEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCSweepEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCDrainMark()
{
    return EventPipeEventBGCDrainMark->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCDrainMark(
    const unsigned __int64 Objects,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCDrainMark())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Objects, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCDrainMark, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCRevisit()
{
    return EventPipeEventBGCRevisit->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCRevisit(
    const unsigned __int64 Pages,
    const unsigned __int64 Objects,
    const unsigned int IsLarge,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCRevisit())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Pages, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Objects, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsLarge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCRevisit, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCOverflow()
{
    return EventPipeEventBGCOverflow->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCOverflow(
    const unsigned __int64 Min,
    const unsigned __int64 Max,
    const unsigned __int64 Objects,
    const unsigned int IsLarge,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCOverflow())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Min, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Max, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Objects, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsLarge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCOverflow, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCOverflow_V1()
{
    return EventPipeEventBGCOverflow_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCOverflow_V1(
    const unsigned __int64 Min,
    const unsigned __int64 Max,
    const unsigned __int64 Objects,
    const unsigned int IsLarge,
    const unsigned short ClrInstanceID,
    const unsigned int GenNumber,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCOverflow_V1())
        return ERROR_SUCCESS;

    char stackBuffer[34];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 34;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Min, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Max, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Objects, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsLarge, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GenNumber, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCOverflow_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCAllocWaitBegin()
{
    return EventPipeEventBGCAllocWaitBegin->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCAllocWaitBegin(
    const unsigned int Reason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCAllocWaitBegin())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCAllocWaitBegin, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGCAllocWaitEnd()
{
    return EventPipeEventBGCAllocWaitEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGCAllocWaitEnd(
    const unsigned int Reason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGCAllocWaitEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Reason, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGCAllocWaitEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFullNotify()
{
    return EventPipeEventGCFullNotify->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCFullNotify(
    const unsigned int GenNumber,
    const unsigned int IsAlloc,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFullNotify())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(GenNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsAlloc, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCFullNotify, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGCFullNotify_V1()
{
    return EventPipeEventGCFullNotify_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGCFullNotify_V1(
    const unsigned int GenNumber,
    const unsigned int IsAlloc,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGCFullNotify_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(GenNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsAlloc, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGCFullNotify_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBGC1stSweepEnd()
{
    return EventPipeEventBGC1stSweepEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBGC1stSweepEnd(
    const unsigned int GenNumber,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBGC1stSweepEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(GenNumber, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBGC1stSweepEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEStartupStart()
{
    return EventPipeEventEEStartupStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEStartupStart(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEStartupStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEStartupStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEStartupStart_V1()
{
    return EventPipeEventEEStartupStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEStartupStart_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEStartupStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEStartupStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEStartupEnd()
{
    return EventPipeEventEEStartupEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEStartupEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEStartupEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEStartupEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEStartupEnd_V1()
{
    return EventPipeEventEEStartupEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEStartupEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEStartupEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEStartupEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEConfigSetup()
{
    return EventPipeEventEEConfigSetup->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEConfigSetup(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEConfigSetup())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEConfigSetup, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEConfigSetup_V1()
{
    return EventPipeEventEEConfigSetup_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEConfigSetup_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEConfigSetup_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEConfigSetup_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEConfigSetupEnd()
{
    return EventPipeEventEEConfigSetupEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEConfigSetupEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEConfigSetupEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEConfigSetupEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEConfigSetupEnd_V1()
{
    return EventPipeEventEEConfigSetupEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEConfigSetupEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEConfigSetupEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEConfigSetupEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLdSysBases()
{
    return EventPipeEventLdSysBases->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLdSysBases(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLdSysBases())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLdSysBases, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLdSysBases_V1()
{
    return EventPipeEventLdSysBases_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLdSysBases_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLdSysBases_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLdSysBases_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLdSysBasesEnd()
{
    return EventPipeEventLdSysBasesEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLdSysBasesEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLdSysBasesEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLdSysBasesEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLdSysBasesEnd_V1()
{
    return EventPipeEventLdSysBasesEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLdSysBasesEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLdSysBasesEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLdSysBasesEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExecExe()
{
    return EventPipeEventExecExe->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExecExe(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExecExe())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExecExe, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExecExe_V1()
{
    return EventPipeEventExecExe_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExecExe_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExecExe_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExecExe_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExecExeEnd()
{
    return EventPipeEventExecExeEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExecExeEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExecExeEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExecExeEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExecExeEnd_V1()
{
    return EventPipeEventExecExeEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExecExeEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExecExeEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExecExeEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMain()
{
    return EventPipeEventMain->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMain(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMain())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMain, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMain_V1()
{
    return EventPipeEventMain_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMain_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMain_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMain_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMainEnd()
{
    return EventPipeEventMainEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMainEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMainEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMainEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMainEnd_V1()
{
    return EventPipeEventMainEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMainEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMainEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMainEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledApplyPolicyStart()
{
    return EventPipeEventApplyPolicyStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventApplyPolicyStart(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledApplyPolicyStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventApplyPolicyStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledApplyPolicyStart_V1()
{
    return EventPipeEventApplyPolicyStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventApplyPolicyStart_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledApplyPolicyStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventApplyPolicyStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledApplyPolicyEnd()
{
    return EventPipeEventApplyPolicyEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventApplyPolicyEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledApplyPolicyEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventApplyPolicyEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledApplyPolicyEnd_V1()
{
    return EventPipeEventApplyPolicyEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventApplyPolicyEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledApplyPolicyEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventApplyPolicyEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLdLibShFolder()
{
    return EventPipeEventLdLibShFolder->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLdLibShFolder(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLdLibShFolder())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLdLibShFolder, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLdLibShFolder_V1()
{
    return EventPipeEventLdLibShFolder_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLdLibShFolder_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLdLibShFolder_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLdLibShFolder_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLdLibShFolderEnd()
{
    return EventPipeEventLdLibShFolderEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLdLibShFolderEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLdLibShFolderEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLdLibShFolderEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLdLibShFolderEnd_V1()
{
    return EventPipeEventLdLibShFolderEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLdLibShFolderEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLdLibShFolderEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLdLibShFolderEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrestubWorker()
{
    return EventPipeEventPrestubWorker->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrestubWorker(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrestubWorker())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrestubWorker, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrestubWorker_V1()
{
    return EventPipeEventPrestubWorker_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrestubWorker_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrestubWorker_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrestubWorker_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrestubWorkerEnd()
{
    return EventPipeEventPrestubWorkerEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrestubWorkerEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrestubWorkerEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrestubWorkerEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrestubWorkerEnd_V1()
{
    return EventPipeEventPrestubWorkerEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrestubWorkerEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrestubWorkerEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrestubWorkerEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGetInstallationStart()
{
    return EventPipeEventGetInstallationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGetInstallationStart(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGetInstallationStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGetInstallationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGetInstallationStart_V1()
{
    return EventPipeEventGetInstallationStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGetInstallationStart_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGetInstallationStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGetInstallationStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGetInstallationEnd()
{
    return EventPipeEventGetInstallationEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGetInstallationEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGetInstallationEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGetInstallationEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGetInstallationEnd_V1()
{
    return EventPipeEventGetInstallationEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGetInstallationEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGetInstallationEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGetInstallationEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledOpenHModule()
{
    return EventPipeEventOpenHModule->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventOpenHModule(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledOpenHModule())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventOpenHModule, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledOpenHModule_V1()
{
    return EventPipeEventOpenHModule_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventOpenHModule_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledOpenHModule_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventOpenHModule_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledOpenHModuleEnd()
{
    return EventPipeEventOpenHModuleEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventOpenHModuleEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledOpenHModuleEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventOpenHModuleEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledOpenHModuleEnd_V1()
{
    return EventPipeEventOpenHModuleEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventOpenHModuleEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledOpenHModuleEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventOpenHModuleEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExplicitBindStart()
{
    return EventPipeEventExplicitBindStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExplicitBindStart(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExplicitBindStart())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExplicitBindStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExplicitBindStart_V1()
{
    return EventPipeEventExplicitBindStart_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExplicitBindStart_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExplicitBindStart_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExplicitBindStart_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExplicitBindEnd()
{
    return EventPipeEventExplicitBindEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExplicitBindEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExplicitBindEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExplicitBindEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledExplicitBindEnd_V1()
{
    return EventPipeEventExplicitBindEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventExplicitBindEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledExplicitBindEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventExplicitBindEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledParseXml()
{
    return EventPipeEventParseXml->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventParseXml(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledParseXml())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventParseXml, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledParseXml_V1()
{
    return EventPipeEventParseXml_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventParseXml_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledParseXml_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventParseXml_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledParseXmlEnd()
{
    return EventPipeEventParseXmlEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventParseXmlEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledParseXmlEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventParseXmlEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledParseXmlEnd_V1()
{
    return EventPipeEventParseXmlEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventParseXmlEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledParseXmlEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventParseXmlEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledInitDefaultDomain()
{
    return EventPipeEventInitDefaultDomain->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventInitDefaultDomain(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledInitDefaultDomain())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventInitDefaultDomain, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledInitDefaultDomain_V1()
{
    return EventPipeEventInitDefaultDomain_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventInitDefaultDomain_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledInitDefaultDomain_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventInitDefaultDomain_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledInitDefaultDomainEnd()
{
    return EventPipeEventInitDefaultDomainEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventInitDefaultDomainEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledInitDefaultDomainEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventInitDefaultDomainEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledInitDefaultDomainEnd_V1()
{
    return EventPipeEventInitDefaultDomainEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventInitDefaultDomainEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledInitDefaultDomainEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventInitDefaultDomainEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledInitSecurity()
{
    return EventPipeEventInitSecurity->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventInitSecurity(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledInitSecurity())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventInitSecurity, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledInitSecurity_V1()
{
    return EventPipeEventInitSecurity_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventInitSecurity_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledInitSecurity_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventInitSecurity_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledInitSecurityEnd()
{
    return EventPipeEventInitSecurityEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventInitSecurityEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledInitSecurityEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventInitSecurityEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledInitSecurityEnd_V1()
{
    return EventPipeEventInitSecurityEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventInitSecurityEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledInitSecurityEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventInitSecurityEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAllowBindingRedirs()
{
    return EventPipeEventAllowBindingRedirs->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAllowBindingRedirs(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAllowBindingRedirs())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAllowBindingRedirs, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAllowBindingRedirs_V1()
{
    return EventPipeEventAllowBindingRedirs_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAllowBindingRedirs_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAllowBindingRedirs_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAllowBindingRedirs_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAllowBindingRedirsEnd()
{
    return EventPipeEventAllowBindingRedirsEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAllowBindingRedirsEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAllowBindingRedirsEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAllowBindingRedirsEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAllowBindingRedirsEnd_V1()
{
    return EventPipeEventAllowBindingRedirsEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAllowBindingRedirsEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAllowBindingRedirsEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAllowBindingRedirsEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEConfigSync()
{
    return EventPipeEventEEConfigSync->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEConfigSync(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEConfigSync())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEConfigSync, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEConfigSync_V1()
{
    return EventPipeEventEEConfigSync_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEConfigSync_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEConfigSync_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEConfigSync_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEConfigSyncEnd()
{
    return EventPipeEventEEConfigSyncEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEConfigSyncEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEConfigSyncEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEConfigSyncEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEEConfigSyncEnd_V1()
{
    return EventPipeEventEEConfigSyncEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEEConfigSyncEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEEConfigSyncEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEEConfigSyncEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionBinding()
{
    return EventPipeEventFusionBinding->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionBinding(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionBinding())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionBinding, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionBinding_V1()
{
    return EventPipeEventFusionBinding_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionBinding_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionBinding_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionBinding_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionBindingEnd()
{
    return EventPipeEventFusionBindingEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionBindingEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionBindingEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionBindingEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionBindingEnd_V1()
{
    return EventPipeEventFusionBindingEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionBindingEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionBindingEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionBindingEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderCatchCall()
{
    return EventPipeEventLoaderCatchCall->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderCatchCall(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderCatchCall())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderCatchCall, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderCatchCall_V1()
{
    return EventPipeEventLoaderCatchCall_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderCatchCall_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderCatchCall_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderCatchCall_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderCatchCallEnd()
{
    return EventPipeEventLoaderCatchCallEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderCatchCallEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderCatchCallEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderCatchCallEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderCatchCallEnd_V1()
{
    return EventPipeEventLoaderCatchCallEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderCatchCallEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderCatchCallEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderCatchCallEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionInit()
{
    return EventPipeEventFusionInit->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionInit(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionInit())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionInit, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionInit_V1()
{
    return EventPipeEventFusionInit_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionInit_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionInit_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionInit_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionInitEnd()
{
    return EventPipeEventFusionInitEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionInitEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionInitEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionInitEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionInitEnd_V1()
{
    return EventPipeEventFusionInitEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionInitEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionInitEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionInitEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionAppCtx()
{
    return EventPipeEventFusionAppCtx->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionAppCtx(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionAppCtx())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionAppCtx, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionAppCtx_V1()
{
    return EventPipeEventFusionAppCtx_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionAppCtx_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionAppCtx_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionAppCtx_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionAppCtxEnd()
{
    return EventPipeEventFusionAppCtxEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionAppCtxEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionAppCtxEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionAppCtxEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionAppCtxEnd_V1()
{
    return EventPipeEventFusionAppCtxEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionAppCtxEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionAppCtxEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionAppCtxEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusion2EE()
{
    return EventPipeEventFusion2EE->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusion2EE(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusion2EE())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusion2EE, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusion2EE_V1()
{
    return EventPipeEventFusion2EE_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusion2EE_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusion2EE_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusion2EE_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusion2EEEnd()
{
    return EventPipeEventFusion2EEEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusion2EEEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusion2EEEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusion2EEEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusion2EEEnd_V1()
{
    return EventPipeEventFusion2EEEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusion2EEEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusion2EEEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusion2EEEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledSecurityCatchCall()
{
    return EventPipeEventSecurityCatchCall->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventSecurityCatchCall(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledSecurityCatchCall())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventSecurityCatchCall, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledSecurityCatchCall_V1()
{
    return EventPipeEventSecurityCatchCall_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventSecurityCatchCall_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledSecurityCatchCall_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventSecurityCatchCall_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledSecurityCatchCallEnd()
{
    return EventPipeEventSecurityCatchCallEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventSecurityCatchCallEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledSecurityCatchCallEnd())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;


    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventSecurityCatchCallEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledSecurityCatchCallEnd_V1()
{
    return EventPipeEventSecurityCatchCallEnd_V1->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventSecurityCatchCallEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledSecurityCatchCallEnd_V1())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventSecurityCatchCallEnd_V1, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCLRStackWalkPrivate()
{
    return EventPipeEventCLRStackWalkPrivate->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCLRStackWalkPrivate(
    const unsigned short ClrInstanceID,
    const unsigned char Reserved1,
    const unsigned char Reserved2,
    const unsigned int FrameCount,
    const void** Stack,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCLRStackWalkPrivate())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Reserved2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FrameCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Stack, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCLRStackWalkPrivate, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleRangeLoadPrivate()
{
    return EventPipeEventModuleRangeLoadPrivate->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleRangeLoadPrivate(
    const unsigned short ClrInstanceID,
    const unsigned __int64 ModuleID,
    const unsigned int RangeBegin,
    const unsigned int RangeSize,
    const unsigned char RangeType,
    const unsigned char IBCType,
    const unsigned short SectionType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleRangeLoadPrivate())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeBegin, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RangeType, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IBCType, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SectionType, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleRangeLoadPrivate, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingPolicyPhaseStart()
{
    return EventPipeEventBindingPolicyPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingPolicyPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingPolicyPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingPolicyPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingPolicyPhaseEnd()
{
    return EventPipeEventBindingPolicyPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingPolicyPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingPolicyPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingPolicyPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingNgenPhaseStart()
{
    return EventPipeEventBindingNgenPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingNgenPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingNgenPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingNgenPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingNgenPhaseEnd()
{
    return EventPipeEventBindingNgenPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingNgenPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingNgenPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingNgenPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingLookupAndProbingPhaseStart()
{
    return EventPipeEventBindingLookupAndProbingPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingLookupAndProbingPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingLookupAndProbingPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingLookupAndProbingPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingLookupAndProbingPhaseEnd()
{
    return EventPipeEventBindingLookupAndProbingPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingLookupAndProbingPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingLookupAndProbingPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingLookupAndProbingPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderPhaseStart()
{
    return EventPipeEventLoaderPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderPhaseEnd()
{
    return EventPipeEventLoaderPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingPhaseStart()
{
    return EventPipeEventBindingPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingPhaseEnd()
{
    return EventPipeEventBindingPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingDownloadPhaseStart()
{
    return EventPipeEventBindingDownloadPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingDownloadPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingDownloadPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingDownloadPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBindingDownloadPhaseEnd()
{
    return EventPipeEventBindingDownloadPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBindingDownloadPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBindingDownloadPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBindingDownloadPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderAssemblyInitPhaseStart()
{
    return EventPipeEventLoaderAssemblyInitPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderAssemblyInitPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderAssemblyInitPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderAssemblyInitPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderAssemblyInitPhaseEnd()
{
    return EventPipeEventLoaderAssemblyInitPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderAssemblyInitPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderAssemblyInitPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderAssemblyInitPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderMappingPhaseStart()
{
    return EventPipeEventLoaderMappingPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderMappingPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderMappingPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderMappingPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderMappingPhaseEnd()
{
    return EventPipeEventLoaderMappingPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderMappingPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderMappingPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderMappingPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderDeliverEventsPhaseStart()
{
    return EventPipeEventLoaderDeliverEventsPhaseStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderDeliverEventsPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderDeliverEventsPhaseStart())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderDeliverEventsPhaseStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledLoaderDeliverEventsPhaseEnd()
{
    return EventPipeEventLoaderDeliverEventsPhaseEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventLoaderDeliverEventsPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledLoaderDeliverEventsPhaseEnd())
        return ERROR_SUCCESS;

    char stackBuffer[146];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 146;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(LoadContextID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FromLoaderCache, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(DynamicLoad, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyCodebase, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventLoaderDeliverEventsPhaseEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEvidenceGenerated()
{
    return EventPipeEventEvidenceGenerated->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEvidenceGenerated(
    const unsigned int Type,
    const unsigned int AppDomain,
    PCWSTR ILImage,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEvidenceGenerated())
        return ERROR_SUCCESS;

    char stackBuffer[74];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 74;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomain, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ILImage, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEvidenceGenerated, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleTransparencyComputationStart()
{
    return EventPipeEventModuleTransparencyComputationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleTransparencyComputationStart(
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleTransparencyComputationStart())
        return ERROR_SUCCESS;

    char stackBuffer[70];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 70;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleTransparencyComputationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledModuleTransparencyComputationEnd()
{
    return EventPipeEventModuleTransparencyComputationEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventModuleTransparencyComputationEnd(
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsAllCritical,
    const BOOL IsAllTransparent,
    const BOOL IsTreatAsSafe,
    const BOOL IsOpportunisticallyCritical,
    const unsigned int SecurityRuleSet,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledModuleTransparencyComputationEnd())
        return ERROR_SUCCESS;

    char stackBuffer[90];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 90;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsAllCritical, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsAllTransparent, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsTreatAsSafe, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsOpportunisticallyCritical, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SecurityRuleSet, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventModuleTransparencyComputationEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTypeTransparencyComputationStart()
{
    return EventPipeEventTypeTransparencyComputationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTypeTransparencyComputationStart(
    PCWSTR Type,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTypeTransparencyComputationStart())
        return ERROR_SUCCESS;

    char stackBuffer[134];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 134;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTypeTransparencyComputationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTypeTransparencyComputationEnd()
{
    return EventPipeEventTypeTransparencyComputationEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTypeTransparencyComputationEnd(
    PCWSTR Type,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsAllCritical,
    const BOOL IsAllTransparent,
    const BOOL IsCritical,
    const BOOL IsTreatAsSafe,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTypeTransparencyComputationEnd())
        return ERROR_SUCCESS;

    char stackBuffer[150];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 150;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Type, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsAllCritical, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsAllTransparent, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsCritical, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsTreatAsSafe, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTypeTransparencyComputationEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodTransparencyComputationStart()
{
    return EventPipeEventMethodTransparencyComputationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodTransparencyComputationStart(
    PCWSTR Method,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodTransparencyComputationStart())
        return ERROR_SUCCESS;

    char stackBuffer[134];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 134;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Method, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodTransparencyComputationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMethodTransparencyComputationEnd()
{
    return EventPipeEventMethodTransparencyComputationEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMethodTransparencyComputationEnd(
    PCWSTR Method,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsCritical,
    const BOOL IsTreatAsSafe,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMethodTransparencyComputationEnd())
        return ERROR_SUCCESS;

    char stackBuffer[142];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 142;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Method, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsCritical, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsTreatAsSafe, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMethodTransparencyComputationEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFieldTransparencyComputationStart()
{
    return EventPipeEventFieldTransparencyComputationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFieldTransparencyComputationStart(
    PCWSTR Field,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFieldTransparencyComputationStart())
        return ERROR_SUCCESS;

    char stackBuffer[134];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 134;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Field, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFieldTransparencyComputationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFieldTransparencyComputationEnd()
{
    return EventPipeEventFieldTransparencyComputationEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFieldTransparencyComputationEnd(
    PCWSTR Field,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsCritical,
    const BOOL IsTreatAsSafe,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFieldTransparencyComputationEnd())
        return ERROR_SUCCESS;

    char stackBuffer[142];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 142;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Field, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsCritical, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsTreatAsSafe, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFieldTransparencyComputationEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTokenTransparencyComputationStart()
{
    return EventPipeEventTokenTransparencyComputationStart->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTokenTransparencyComputationStart(
    const unsigned int Token,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTokenTransparencyComputationStart())
        return ERROR_SUCCESS;

    char stackBuffer[74];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 74;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Token, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTokenTransparencyComputationStart, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledTokenTransparencyComputationEnd()
{
    return EventPipeEventTokenTransparencyComputationEnd->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventTokenTransparencyComputationEnd(
    const unsigned int Token,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsCritical,
    const BOOL IsTreatAsSafe,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledTokenTransparencyComputationEnd())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(Token, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Module, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsCritical, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(IsTreatAsSafe, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventTokenTransparencyComputationEnd, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledNgenBindEvent()
{
    return EventPipeEventNgenBindEvent->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventNgenBindEvent(
    const unsigned short ClrInstanceID,
    const unsigned __int64 BindingID,
    const unsigned int ReasonCode,
    PCWSTR AssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledNgenBindEvent())
        return ERROR_SUCCESS;

    char stackBuffer[78];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 78;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(BindingID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ReasonCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AssemblyName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventNgenBindEvent, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFailFast()
{
    return EventPipeEventFailFast->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFailFast(
    PCWSTR FailFastUserMessage,
    const void* FailedEIP,
    const unsigned int OSExitCode,
    const unsigned int ClrExitCode,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFailFast())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(FailFastUserMessage, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(FailedEIP, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(OSExitCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrExitCode, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFailFast, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvFinalizeObject()
{
    return EventPipeEventPrvFinalizeObject->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvFinalizeObject(
    const void* TypeID,
    const void* ObjectID,
    const unsigned short ClrInstanceID,
    PCWSTR TypeName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvFinalizeObject())
        return ERROR_SUCCESS;

    char stackBuffer[82];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 82;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvFinalizeObject, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCCWRefCountChangeAnsi()
{
    return EventPipeEventCCWRefCountChangeAnsi->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCCWRefCountChangeAnsi(
    const void* HandleID,
    const void* ObjectID,
    const void* COMInterfacePointer,
    const unsigned int NewRefCount,
    const unsigned __int64 AppDomainID,
    LPCSTR ClassName,
    LPCSTR NameSpace,
    PCWSTR Operation,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCCWRefCountChangeAnsi())
        return ERROR_SUCCESS;

    char stackBuffer[166];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 166;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(COMInterfacePointer, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewRefCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClassName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NameSpace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Operation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCCWRefCountChangeAnsi, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvSetGCHandle()
{
    return EventPipeEventPrvSetGCHandle->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvSetGCHandle(
    const void* HandleID,
    const void* ObjectID,
    const unsigned int Kind,
    const unsigned int Generation,
    const unsigned __int64 AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvSetGCHandle())
        return ERROR_SUCCESS;

    char stackBuffer[34];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 34;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Kind, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Generation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvSetGCHandle, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPrvDestroyGCHandle()
{
    return EventPipeEventPrvDestroyGCHandle->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPrvDestroyGCHandle(
    const void* HandleID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPrvDestroyGCHandle())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPrvDestroyGCHandle, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionMessageEvent()
{
    return EventPipeEventFusionMessageEvent->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionMessageEvent(
    const unsigned short ClrInstanceID,
    const BOOL Prepend,
    PCWSTR Message,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionMessageEvent())
        return ERROR_SUCCESS;

    char stackBuffer[70];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 70;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Prepend, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Message, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionMessageEvent, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledFusionErrorCodeEvent()
{
    return EventPipeEventFusionErrorCodeEvent->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventFusionErrorCodeEvent(
    const unsigned short ClrInstanceID,
    const unsigned int Category,
    const unsigned int ErrorCode,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledFusionErrorCodeEvent())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Category, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ErrorCode, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventFusionErrorCodeEvent, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledPinPlugAtGCTime()
{
    return EventPipeEventPinPlugAtGCTime->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventPinPlugAtGCTime(
    const void* PlugStart,
    const void* PlugEnd,
    const void* GapBeforeSize,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledPinPlugAtGCTime())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(PlugStart, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(PlugEnd, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(GapBeforeSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventPinPlugAtGCTime, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCCWRefCountChange()
{
    return EventPipeEventCCWRefCountChange->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCCWRefCountChange(
    const void* HandleID,
    const void* ObjectID,
    const void* COMInterfacePointer,
    const unsigned int NewRefCount,
    const unsigned __int64 AppDomainID,
    PCWSTR ClassName,
    PCWSTR NameSpace,
    PCWSTR Operation,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCCWRefCountChange())
        return ERROR_SUCCESS;

    char stackBuffer[230];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 230;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(HandleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ObjectID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(COMInterfacePointer, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NewRefCount, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(AppDomainID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClassName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(NameSpace, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Operation, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCCWRefCountChange, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledAllocRequest()
{
    return EventPipeEventAllocRequest->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventAllocRequest(
    const void* LoaderHeapPtr,
    const void* MemoryAddress,
    const unsigned int RequestSize,
    const unsigned int Unused1,
    const unsigned __int64 Unused2,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledAllocRequest())
        return ERROR_SUCCESS;

    char stackBuffer[34];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 34;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(LoaderHeapPtr, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MemoryAddress, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(RequestSize, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Unused1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Unused2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventAllocRequest, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMulticoreJit()
{
    return EventPipeEventMulticoreJit->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMulticoreJit(
    const unsigned short ClrInstanceID,
    PCWSTR String1,
    PCWSTR String2,
    const signed int Int1,
    const signed int Int2,
    const signed int Int3,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMulticoreJit())
        return ERROR_SUCCESS;

    char stackBuffer[142];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 142;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(String1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(String2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Int1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Int2, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Int3, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMulticoreJit, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledMulticoreJitMethodCodeReturned()
{
    return EventPipeEventMulticoreJitMethodCodeReturned->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventMulticoreJitMethodCodeReturned(
    const unsigned short ClrInstanceID,
    const unsigned __int64 ModuleID,
    const unsigned __int64 MethodID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledMulticoreJitMethodCodeReturned())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ModuleID, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(MethodID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventMulticoreJitMethodCodeReturned, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledIInspectableRuntimeClassName()
{
    return EventPipeEventIInspectableRuntimeClassName->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventIInspectableRuntimeClassName(
    PCWSTR TypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledIInspectableRuntimeClassName())
        return ERROR_SUCCESS;

    char stackBuffer[66];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 66;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventIInspectableRuntimeClassName, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledWinRTUnbox()
{
    return EventPipeEventWinRTUnbox->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventWinRTUnbox(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledWinRTUnbox())
        return ERROR_SUCCESS;

    char stackBuffer[130];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 130;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SecondTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventWinRTUnbox, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCreateRCW()
{
    return EventPipeEventCreateRCW->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCreateRCW(
    PCWSTR TypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCreateRCW())
        return ERROR_SUCCESS;

    char stackBuffer[66];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 66;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCreateRCW, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledRCWVariance()
{
    return EventPipeEventRCWVariance->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventRCWVariance(
    PCWSTR TypeName,
    PCWSTR InterfaceTypeName,
    PCWSTR VariantInterfaceTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledRCWVariance())
        return ERROR_SUCCESS;

    char stackBuffer[194];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 194;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InterfaceTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VariantInterfaceTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventRCWVariance, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledRCWIEnumerableCasting()
{
    return EventPipeEventRCWIEnumerableCasting->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventRCWIEnumerableCasting(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledRCWIEnumerableCasting())
        return ERROR_SUCCESS;

    char stackBuffer[130];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 130;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SecondTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventRCWIEnumerableCasting, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCreateCCW()
{
    return EventPipeEventCreateCCW->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCreateCCW(
    PCWSTR TypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCreateCCW())
        return ERROR_SUCCESS;

    char stackBuffer[66];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 66;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCreateCCW, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledCCWVariance()
{
    return EventPipeEventCCWVariance->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventCCWVariance(
    PCWSTR TypeName,
    PCWSTR InterfaceTypeName,
    PCWSTR VariantInterfaceTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledCCWVariance())
        return ERROR_SUCCESS;

    char stackBuffer[194];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 194;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(InterfaceTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(VariantInterfaceTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventCCWVariance, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledObjectVariantMarshallingToNative()
{
    return EventPipeEventObjectVariantMarshallingToNative->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventObjectVariantMarshallingToNative(
    PCWSTR TypeName,
    const signed int Int1,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledObjectVariantMarshallingToNative())
        return ERROR_SUCCESS;

    char stackBuffer[70];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 70;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Int1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventObjectVariantMarshallingToNative, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGetTypeFromGUID()
{
    return EventPipeEventGetTypeFromGUID->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGetTypeFromGUID(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGetTypeFromGUID())
        return ERROR_SUCCESS;

    char stackBuffer[130];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 130;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SecondTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGetTypeFromGUID, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledGetTypeFromProgID()
{
    return EventPipeEventGetTypeFromProgID->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventGetTypeFromProgID(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledGetTypeFromProgID())
        return ERROR_SUCCESS;

    char stackBuffer[130];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 130;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SecondTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventGetTypeFromProgID, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledConvertToCallbackEtw()
{
    return EventPipeEventConvertToCallbackEtw->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventConvertToCallbackEtw(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledConvertToCallbackEtw())
        return ERROR_SUCCESS;

    char stackBuffer[130];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 130;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(SecondTypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventConvertToCallbackEtw, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledBeginCreateManagedReference()
{
    return EventPipeEventBeginCreateManagedReference->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventBeginCreateManagedReference(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledBeginCreateManagedReference())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventBeginCreateManagedReference, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledEndCreateManagedReference()
{
    return EventPipeEventEndCreateManagedReference->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventEndCreateManagedReference(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledEndCreateManagedReference())
        return ERROR_SUCCESS;

    char stackBuffer[32];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 32;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventEndCreateManagedReference, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

BOOL EventPipeEventEnabledObjectVariantMarshallingToManaged()
{
    return EventPipeEventObjectVariantMarshallingToManaged->IsEnabled();
}

extern "C" ULONG EventPipeWriteEventObjectVariantMarshallingToManaged(
    PCWSTR TypeName,
    const signed int Int1,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!EventPipeEventEnabledObjectVariantMarshallingToManaged())
        return ERROR_SUCCESS;

    char stackBuffer[70];
    char *buffer = stackBuffer;
    size_t offset = 0;
    size_t size = 70;
    bool fixedBuffer = true;

    bool success = true;
    success &= WriteToBuffer(TypeName, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(Int1, buffer, offset, size, fixedBuffer);
    success &= WriteToBuffer(ClrInstanceID, buffer, offset, size, fixedBuffer);

    if (!success)
    {
        if (!fixedBuffer)
            delete[] buffer;
        return ERROR_WRITE_FAULT;
    }

    EventPipe::WriteEvent(*EventPipeEventObjectVariantMarshallingToManaged, (BYTE *)buffer, (unsigned int)offset, ActivityId, RelatedActivityId);

    if (!fixedBuffer)
        delete[] buffer;

    return ERROR_SUCCESS;
}

extern "C" void InitDotNETRuntimePrivate()
{
    EventPipeProviderDotNETRuntimePrivate = EventPipe::CreateProvider(SL(DotNETRuntimePrivateName), EventPipeEtwCallbackDotNETRuntimePrivate);
    EventPipeEventGCDecision = EventPipeProviderDotNETRuntimePrivate->AddEvent(1,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGCDecision_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(1,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventGCSettings = EventPipeProviderDotNETRuntimePrivate->AddEvent(2,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGCSettings_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(2,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventGCOptimized = EventPipeProviderDotNETRuntimePrivate->AddEvent(3,1,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCOptimized_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(3,1,1,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCPerHeapHistory = EventPipeProviderDotNETRuntimePrivate->AddEvent(4,1,2,EventPipeEventLevel::Informational,true);
    EventPipeEventGCPerHeapHistory_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(4,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventGCGlobalHeapHistory = EventPipeProviderDotNETRuntimePrivate->AddEvent(5,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGCGlobalHeapHistory_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(5,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventGCJoin = EventPipeProviderDotNETRuntimePrivate->AddEvent(6,1,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventGCJoin_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(6,1,1,EventPipeEventLevel::Verbose,true);
    EventPipeEventPrvGCMarkStackRoots = EventPipeProviderDotNETRuntimePrivate->AddEvent(7,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventPrvGCMarkStackRoots_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(7,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventPrvGCMarkFinalizeQueueRoots = EventPipeProviderDotNETRuntimePrivate->AddEvent(8,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventPrvGCMarkFinalizeQueueRoots_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(8,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventPrvGCMarkHandles = EventPipeProviderDotNETRuntimePrivate->AddEvent(9,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventPrvGCMarkHandles_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(9,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventPrvGCMarkCards = EventPipeProviderDotNETRuntimePrivate->AddEvent(10,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventPrvGCMarkCards_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(10,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCBegin = EventPipeProviderDotNETRuntimePrivate->AddEvent(11,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGC1stNonConEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(12,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGC1stConEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(13,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGC2ndNonConBegin = EventPipeProviderDotNETRuntimePrivate->AddEvent(14,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGC2ndNonConEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(15,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGC2ndConBegin = EventPipeProviderDotNETRuntimePrivate->AddEvent(16,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGC2ndConEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(17,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCPlanEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(18,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCSweepEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(19,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCDrainMark = EventPipeProviderDotNETRuntimePrivate->AddEvent(20,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCRevisit = EventPipeProviderDotNETRuntimePrivate->AddEvent(21,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCOverflow = EventPipeProviderDotNETRuntimePrivate->AddEvent(22,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCOverflow_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(22,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCAllocWaitBegin = EventPipeProviderDotNETRuntimePrivate->AddEvent(23,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBGCAllocWaitEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(24,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGCFullNotify = EventPipeProviderDotNETRuntimePrivate->AddEvent(25,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGCFullNotify_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(25,1,1,EventPipeEventLevel::Informational,true);
    EventPipeEventBGC1stSweepEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(26,1,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEEStartupStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(80,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEEStartupStart_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(80,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventEEStartupEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(81,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEEStartupEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(81,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventEEConfigSetup = EventPipeProviderDotNETRuntimePrivate->AddEvent(82,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEEConfigSetup_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(82,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventEEConfigSetupEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(83,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEEConfigSetupEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(83,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventLdSysBases = EventPipeProviderDotNETRuntimePrivate->AddEvent(84,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLdSysBases_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(84,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventLdSysBasesEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(85,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLdSysBasesEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(85,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventExecExe = EventPipeProviderDotNETRuntimePrivate->AddEvent(86,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExecExe_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(86,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventExecExeEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(87,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExecExeEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(87,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventMain = EventPipeProviderDotNETRuntimePrivate->AddEvent(88,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMain_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(88,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventMainEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(89,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMainEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(89,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventApplyPolicyStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(90,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventApplyPolicyStart_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(90,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventApplyPolicyEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(91,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventApplyPolicyEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(91,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventLdLibShFolder = EventPipeProviderDotNETRuntimePrivate->AddEvent(92,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLdLibShFolder_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(92,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventLdLibShFolderEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(93,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLdLibShFolderEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(93,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventPrestubWorker = EventPipeProviderDotNETRuntimePrivate->AddEvent(94,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventPrestubWorker_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(94,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventPrestubWorkerEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(95,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventPrestubWorkerEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(95,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventGetInstallationStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(96,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGetInstallationStart_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(96,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventGetInstallationEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(97,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGetInstallationEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(97,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventOpenHModule = EventPipeProviderDotNETRuntimePrivate->AddEvent(98,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventOpenHModule_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(98,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventOpenHModuleEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(99,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventOpenHModuleEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(99,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventExplicitBindStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(100,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExplicitBindStart_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(100,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventExplicitBindEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(101,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventExplicitBindEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(101,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventParseXml = EventPipeProviderDotNETRuntimePrivate->AddEvent(102,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventParseXml_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(102,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventParseXmlEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(103,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventParseXmlEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(103,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventInitDefaultDomain = EventPipeProviderDotNETRuntimePrivate->AddEvent(104,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventInitDefaultDomain_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(104,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventInitDefaultDomainEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(105,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventInitDefaultDomainEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(105,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventInitSecurity = EventPipeProviderDotNETRuntimePrivate->AddEvent(106,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventInitSecurity_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(106,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventInitSecurityEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(107,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventInitSecurityEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(107,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAllowBindingRedirs = EventPipeProviderDotNETRuntimePrivate->AddEvent(108,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAllowBindingRedirs_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(108,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventAllowBindingRedirsEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(109,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventAllowBindingRedirsEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(109,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventEEConfigSync = EventPipeProviderDotNETRuntimePrivate->AddEvent(110,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEEConfigSync_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(110,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventEEConfigSyncEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(111,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEEConfigSyncEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(111,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionBinding = EventPipeProviderDotNETRuntimePrivate->AddEvent(112,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionBinding_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(112,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionBindingEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(113,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionBindingEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(113,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderCatchCall = EventPipeProviderDotNETRuntimePrivate->AddEvent(114,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderCatchCall_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(114,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderCatchCallEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(115,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderCatchCallEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(115,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionInit = EventPipeProviderDotNETRuntimePrivate->AddEvent(116,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionInit_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(116,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionInitEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(117,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionInitEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(117,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionAppCtx = EventPipeProviderDotNETRuntimePrivate->AddEvent(118,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionAppCtx_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(118,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionAppCtxEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(119,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionAppCtxEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(119,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventFusion2EE = EventPipeProviderDotNETRuntimePrivate->AddEvent(120,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusion2EE_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(120,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventFusion2EEEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(121,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusion2EEEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(121,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventSecurityCatchCall = EventPipeProviderDotNETRuntimePrivate->AddEvent(122,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventSecurityCatchCall_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(122,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventSecurityCatchCallEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(123,2147483648,0,EventPipeEventLevel::Informational,true);
    EventPipeEventSecurityCatchCallEnd_V1 = EventPipeProviderDotNETRuntimePrivate->AddEvent(123,2147483648,1,EventPipeEventLevel::Informational,true);
    EventPipeEventCLRStackWalkPrivate = EventPipeProviderDotNETRuntimePrivate->AddEvent(151,1073741824,0,EventPipeEventLevel::LogAlways,true);
    EventPipeEventModuleRangeLoadPrivate = EventPipeProviderDotNETRuntimePrivate->AddEvent(158,536870912,0,EventPipeEventLevel::Informational,false);
    EventPipeEventBindingPolicyPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(159,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingPolicyPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(160,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingNgenPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(161,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingNgenPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(162,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingLookupAndProbingPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(163,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingLookupAndProbingPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(164,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(165,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(166,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(167,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(168,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingDownloadPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(169,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBindingDownloadPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(170,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderAssemblyInitPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(171,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderAssemblyInitPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(172,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderMappingPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(173,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderMappingPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(174,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderDeliverEventsPhaseStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(175,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventLoaderDeliverEventsPhaseEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(176,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEvidenceGenerated = EventPipeProviderDotNETRuntimePrivate->AddEvent(177,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleTransparencyComputationStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(178,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventModuleTransparencyComputationEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(179,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventTypeTransparencyComputationStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(180,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventTypeTransparencyComputationEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(181,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodTransparencyComputationStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(182,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMethodTransparencyComputationEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(183,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFieldTransparencyComputationStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(184,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFieldTransparencyComputationEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(185,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventTokenTransparencyComputationStart = EventPipeProviderDotNETRuntimePrivate->AddEvent(186,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventTokenTransparencyComputationEnd = EventPipeProviderDotNETRuntimePrivate->AddEvent(187,1024,0,EventPipeEventLevel::Informational,true);
    EventPipeEventNgenBindEvent = EventPipeProviderDotNETRuntimePrivate->AddEvent(188,8,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFailFast = EventPipeProviderDotNETRuntimePrivate->AddEvent(191,0,0,EventPipeEventLevel::Critical,true);
    EventPipeEventPrvFinalizeObject = EventPipeProviderDotNETRuntimePrivate->AddEvent(192,1,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventCCWRefCountChangeAnsi = EventPipeProviderDotNETRuntimePrivate->AddEvent(193,8192,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventPrvSetGCHandle = EventPipeProviderDotNETRuntimePrivate->AddEvent(194,16384,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventPrvDestroyGCHandle = EventPipeProviderDotNETRuntimePrivate->AddEvent(195,16384,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventFusionMessageEvent = EventPipeProviderDotNETRuntimePrivate->AddEvent(196,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventFusionErrorCodeEvent = EventPipeProviderDotNETRuntimePrivate->AddEvent(197,2,0,EventPipeEventLevel::Informational,true);
    EventPipeEventPinPlugAtGCTime = EventPipeProviderDotNETRuntimePrivate->AddEvent(199,1,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventCCWRefCountChange = EventPipeProviderDotNETRuntimePrivate->AddEvent(200,8192,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventAllocRequest = EventPipeProviderDotNETRuntimePrivate->AddEvent(310,16,0,EventPipeEventLevel::Verbose,true);
    EventPipeEventMulticoreJit = EventPipeProviderDotNETRuntimePrivate->AddEvent(201,131072,0,EventPipeEventLevel::Informational,true);
    EventPipeEventMulticoreJitMethodCodeReturned = EventPipeProviderDotNETRuntimePrivate->AddEvent(202,131072,0,EventPipeEventLevel::Informational,true);
    EventPipeEventIInspectableRuntimeClassName = EventPipeProviderDotNETRuntimePrivate->AddEvent(400,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventWinRTUnbox = EventPipeProviderDotNETRuntimePrivate->AddEvent(401,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventCreateRCW = EventPipeProviderDotNETRuntimePrivate->AddEvent(402,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventRCWVariance = EventPipeProviderDotNETRuntimePrivate->AddEvent(403,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventRCWIEnumerableCasting = EventPipeProviderDotNETRuntimePrivate->AddEvent(404,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventCreateCCW = EventPipeProviderDotNETRuntimePrivate->AddEvent(405,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventCCWVariance = EventPipeProviderDotNETRuntimePrivate->AddEvent(406,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventObjectVariantMarshallingToNative = EventPipeProviderDotNETRuntimePrivate->AddEvent(407,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGetTypeFromGUID = EventPipeProviderDotNETRuntimePrivate->AddEvent(408,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventGetTypeFromProgID = EventPipeProviderDotNETRuntimePrivate->AddEvent(409,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventConvertToCallbackEtw = EventPipeProviderDotNETRuntimePrivate->AddEvent(410,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventBeginCreateManagedReference = EventPipeProviderDotNETRuntimePrivate->AddEvent(411,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventEndCreateManagedReference = EventPipeProviderDotNETRuntimePrivate->AddEvent(412,32,0,EventPipeEventLevel::Informational,true);
    EventPipeEventObjectVariantMarshallingToManaged = EventPipeProviderDotNETRuntimePrivate->AddEvent(413,32,0,EventPipeEventLevel::Informational,true);
}
